

import os,fnmatch,glob,string,math,types,copy
import Tkinter, Pmw
from tkColorChooser import askcolor
import copy
#print 'GUI------------------------\n',dir()
#print 'Pmw------------------------\n',dir(Pmw)
#print 'Tkinter------------------------\n',dir(Tkinter)

class PhotoImage(Tkinter.PhotoImage):
    """
    Extends the functions of the Tkinter PhotoImage class.
    """
    def data(self):
        """Returns string formatted data"""
        return self.tk.call(self.name,'data')

    def rescale(self,scale):
        """
        Returns rescaled image. scale=1 means same size.
        """

        rows=string.split(self.data()[1:-1],'} {')
        #print 'len(rows)',len(rows)

        row_n=len(rows)
        #cols=string.split(rows[0],' ')
        col_n=len(string.split(rows[0],' '))
        
        inc_x=1.0/scale
        inc_y=1.0/scale
        x=0
        row_ind_prev=-1
        
        newrows=[]
        row_ind=0
        #newcol_ind=0
        #print 'row_n,col_n,inc_x,inc_y',row_n,col_n,inc_x,inc_y
        while row_ind<=row_n-1:
            if row_ind!=row_ind_prev:
                row_ind_prev= row_ind   
                # compute columns
                y=0
                cols=string.split(rows[row_ind],' ')
                #print rows[row_ind]
                #print '\n\n',cols
                
                #newcols=[]
                newcol=''
                while int(y)<=col_n-1:
                    newcol+=cols[int(y)]+' '
                    y+=inc_y
                    #print 'int(y)',int(y)
            
            newrows.append(newcol[0:-1])
            x+=inc_x
            row_ind=int(x)
            #print row_ind,':',x,newcol
            

        #data=string.join(newrows,'} {')
        #return self.data()
        #self.put('{'+string.join(newrows,'} {')+'}')
        return '{'+string.join(newrows,'} {')+'}'

    def magnify(self,percent):
        """
        Returns copy of photoimage, but magnified.
        Percent will be matched to ...,25, 50, 100, 200, 400, ...
        """
        #print 'magnify',percent
        if percent==100:
            #print '  copy'
            return self.copy()
        elif percent<100:
            #print '  subsample',int(100.0/percent)
            return self.subsample(int(100.0/percent))
        else:
            #print '  zoom ',int(0.01*percent)
            return self.zoom(int(0.01*percent))
    
class CostEdit:
    """
    Dialog to edit costs.
    """
    def __init__(self,descriptor,costtable,currency,parent=None,
                 applybutton_command=None):
        self.parent=parent
        self.descriptor=descriptor
        name=descriptor['key']
        self.applybutton_command=applybutton_command
        self.descriptor=descriptor
        self.costtable=costtable
        self.currency=currency
        self.dialog=Panel(parent, title='Edit '+name,
                                        make_cmd=self.make_panel,
                                        refresh_cmd=self.refresh_panel,
                                        apply_cmd=self.apply_panel,
                                        close_cmd=self.close_panel)
        
        
##        self.dialog=Pmw.Dialog(parent, buttons = ('Apply', 'Cancel'),
##                                  defaultbutton = 'Apply', title =
##                                  'Edit '+name, command =
##                                  self.on_button )
        
    def make_panel(self,parent,widgets):
        """
        Create widgets for panel.
        """
      
        quantities=self.costtable.keys()
        quantities.sort()
        table=[]
        for quantity in quantities:
            table.append([quantity,self.costtable[quantity]])

        
        widgets['editor']=TableEditor(table,parent,
                                col_descriptors=[{'key':'Quantity',
                                                  'type':'integer',
                                                  'width':4,
                                                  'mode':'write',
                                                  'valid':{'max' : 10**8}},
                                                  self.descriptor],
                                #width=1.57*200#,
                                height=200,
                                )
        widgets['editor'].pack(expand = 1,fill='both')
        #self.dialog.activate(globalMode = 'nograb')
        #self.dialog.activate(globalMode = 1)
        
    def refresh_panel(self,parent,widgets):
        """
        Refresh widgets for panel.
        """
        pass

    def apply_panel(self,parent,widgets):
        """
        Read cost table 
        """
        if self.applybutton_command: # read out new costs costtable={}
                #print 'on_button',self.editor.get_contents()
                for entry in widgets['editor'].get_contents():
                    self.costtable[entry[0]]=entry[1]
                
                    
                self.applybutton_command(self.descriptor,
                                         self.costtable,
                                         self.parent)
                self.close()
        
      

    def close_panel(self,parent,widgets):
        """
        Do something before simpanel is closed.
        Here the pointer to the panel is set to None.
        """
        self.close()
        


    def close(self):
        #self.dialog.deactivate('Cancel')
        self.dialog.destroy()
        del self.dialog



class Panel(Tkinter.Toplevel):
    """
    Generic control panel dialog window for objects or single modules.
    The obj must have a make_controlpanel method which creates a
    frame in the control panel.The object must also provide a
    close_controlpanel option.
    """
    def __init__(self,parent=None,
                 title='Panel',
                 make_cmd=None,
                 refresh_cmd=None,
                 apply_cmd=None,
                 close_cmd=None,
                 width=1.57*350,
                 height=350):
        Tkinter.Toplevel.__init__(self,parent,
                                  width=width,
                                  height=height)
        self.protocol('WM_DELETE_WINDOW',self.close)
        

        # store away costum commands
        self.make_cmd=make_cmd   # creation of widgets
        self.refresh_cmd=refresh_cmd # update of widgets
        self.apply_cmd=apply_cmd  # reading of widget values
        self.close_cmd=close_cmd  # actions before panel is closed
                                  
        self.set_title(title)

        # panel widget used as root for all widgets on the panel
        self.frame=Tkinter.Frame(self,bd=2,relief='groove')

        #  widgets dir for all widgets on the panel
        self.widgets={}

        


        # Create a buttonbox to configure the notebook and pack it first.
        buttonbox = ButtonArray(self,
                                button_array=\
                                [('OK', self.apply_and_close),
                                 #('Apply', self.apply),
                                 ('Cancel',self.close)],
                                defaultbutton='OK',
                                )
        buttonbox.pack(side = 'bottom', fill = 'x')
        
        
        # fill in panel with widgets
        self.create()

        # set initial panel size
        #self.hullwidth=width
        #self.hullheight=height
        
        self.frame.pack(expand=1,fill='both')
        
                
    def set_title(self,title='Panel'):
        self.title(title)

    def create(self):
        """
        Create panel widgets
        """
        self._destroy_widgets()
        if self.make_cmd: self.make_cmd(self.frame,self.widgets)
        self.refresh()

    def refresh(self):
        """
        Refresh panel and costum update widget values.
        """
        if self.refresh_cmd: self.refresh_cmd(self.frame,self.widgets)

    def apply_and_close(self):
        """
        Apply widget values to whatever costum object and close.
        """
        # only aclose when applied successfully
        if self.apply():
            self.close()
        
    def apply(self):
        """
        Apply widget values to whatever costum object.
        """
        if self.apply_cmd:
            return self.apply_cmd(self.frame,self.widgets)
        else:
            return 1

        
        
    def _destroy_widgets(self):
        """
        Destroy all widgets onb the panel
        """
        for widgets in self.widgets.values():
            widgets.destroy()
            
        self.widgets={}

            
    def close(self,event=None):
        """
        Destroys all widgets and itself.
        """
        if self.close_cmd: self.close_cmd(self.frame,self.widgets)
        self._destroy_widgets()
        self.frame.destroy()
        self.destroy()


class Controlpanel(Tkinter.Toplevel):
    """
    Generic control panel dialog window for objects or single modules.
    The obj must have a make_controlpanel method which creates a
    frame in the control panel.The object must also provide a
    close_controlpanel option.
    """
    def __init__(self,parent,target=None):
        Tkinter.Toplevel.__init__(self,None,
                                  width=1.57*350,
                                  height=350)
        self.protocol('WM_DELETE_WINDOW',self.close_cp)
        

        # widget or object that initialized this control panel
        self.parent=parent
        self.controlpanel=None
        
        # variavles for page structure
        self.pages=None
        self.page_updatecommands={}
        self.page_widgets={}

        # this dir with widgets is only used if no page structure is used
        self.widgets={}
        self.hullwidth=1.57*350
        self.hullheight=350
        self.panelframe=Tkinter.Frame(self)
        

        # Create a buttonbox to configure the notebook and pack it first.
        buttonbox = ButtonArray(self,
                                button_array=\
                                [('Update', self.update_cp),
                                 ('Show text-info',self.show_info),
                                 ('Save text-info...',self.save_info),
                                 ('Close',self.close_cp)],
                                defaultbutton='Update',
                                )
        
        buttonbox.pack(side = 'bottom', fill = 'x')
        
        # initial Target object or module 
        self.target=None
        
        # fill in controlpanel with infos about target object
        self.update_with_target(target)
        self.panelframe.pack(expand=1,fill='both')
        
        
                
    def set_title(self):
        title='Control-Panel'
        if self.target:
            title=title+' of '+self.target.id
        self.title(title)
        
      
    def update_with_target(self,target):
        """
        Change/Update target object.
        """
        #print 'update_with_target page_widgets=\n'
        if target == None:
            self.clear_cp()
            self.target=target
            self.set_title()
            
        # is it a new target that can update the control panel ?
        elif (target!=self.target)&\
             (hasattr(target,'make_panel')):
            self.clear_cp()
            self.target=target
            self.set_title()
            self.init_flag=1
            target.make_panel(self,parent=self.panelframe,widgets=self.widgets)
            self.init_flag=0
            #self.targetpanel=Panel(target,self.panelframe)
            # target.get_panel(self.panelframe)
            #self.targetpanel.pack(expand=1)
            #print 'update_with_target after make\n '
  
    def update_cp(self,event=None):
        """
        Update widgets.
        """
        if self.target:
            if self.widgets:
                self.target.update_panel()
            elif self.pages:
                self.update_page()
            
        
    def clear_cp(self,page_name=''):
        """
        Clear all pages.
        """
        for widgets in self.widgets.keys():
            widgets.destroy()

        self.widgets={}
            
        if self.pages:
            self.pages.destroy()
            self.page_updatecommands={}
            self.page_widgets={}
            
    def close_cp(self,event=None):
        self.clear_cp()
        if self.target:
            if self.parent:
                # parent may no more exist...
                try:
                    self.parent.close_controlpanel()
                except:
                    pass
        # close spanned controlpanel
        #if self.controlpanel:
        #    self.controlpanel.close_cp()
        self.destroy()

    def open_controlpanel(self,target):
        """
        Open or update a centralised controlpanel, started by this
        control-panel
        """
        
        if self.controlpanel:
            self.controlpanel.update_with_target(target)
        else:
            self.controlpanel=Controlpanel(self,target)

    def show_info(self):
        """
        Print state of selected module in terminal window.
        """
        if self.target:
            self.target.print_info()
            
            #self.target.show_info()
            #if self.target.obj:
            #    print '----------'
            #    print 'timestamp:',self.target.obj.sim.time


    def save_info(self):
        """
        Print state of selected module in terminal window.
        """
        if self.target:
            self.target.save_info()
            
    def close_controlpanel(self):
        """
        This method is called when this controlpanel-panel called
        control panel, and this other control panel
        is about to close.
        """
        self.controlpanel=None
        
    def make_standardpanel(self):
        # Create notebook-like pages widget
        self.pages = Pmw.NoteBook(self.panelframe,
                                  tabpos = 'n',
                                  createcommand = self.update_page,
                                  #lowercommand = PrintOne('Lower'),
                                  #raisecommand = self.update_cp,
                                  hull_width = self.hullwidth,
                                  hull_height = self.hullheight,
                                  )
        self.make_page('Performance',self.target.make_performancepage,
                       self.target.update_performancepage)

        self.make_page('Costs',
                       self.target.make_costspage,self.target.update_costspage)

        self.make_page('Tasks',
                       self.target.make_taskspage,self.target.update_taskspage)

        self.pages.tab('Performance').focus_set()
        self.pages.pack(expand = 1,fill='both')
        

    def make_page(self,page_name,page_makecommand,page_updatecommand):
        #print 'make_page',page_name
        # store away update command
        self.page_updatecommands[page_name]=page_updatecommand
                
        page=self.pages.add(page_name)

        # create widgets
        self.page_widgets[page_name]={'controlpanel':self,
                                      'panelframe':self.panelframe}
        page_makecommand(page,self.page_widgets[page_name])
        
        #self.pages.setnaturalsize()

    def update_page(self,page_name=''):
        """
        Update of a specific page, if the notebook structure has been
        initialized.
        
        May be overwritten by specific class.
        """
        #print 'update_page',page_name,self.init_flag
        if not self.init_flag:
            if self.pages:
                if page_name=='':
                    page_name=self.pages.getcurselection()

                if self.page_updatecommands.has_key(page_name):
                    self.page_updatecommands[page_name](
                        self.panelframe,self.page_widgets[page_name])
    

class DataSet:
    """
    Mixin for table and dataset functions using descriptor formatting.
    """
    def make_descriptorwidget(self,parent,descriptor,
                        showunits_flag=1,justify='center',**args):
        
        name=self.get_descriptor_name(descriptor)
        if showunits_flag & descriptor.has_key('units'):
            name+=' ['+self.get_unit_str(descriptor)+']'
        return Tkinter.Label(parent,text=name,**args)

    def make_unitwidget(self,parent,descriptor,valuewidget=None,**kw):
        unit_name=self.get_unit_str(descriptor)
        if unit_name:
            return Tkinter.Label(parent,
                                 text=unit_name,
                                 **kw)
        else:
            return None

    def get_descriptor_name(self,descriptor):
        if descriptor.has_key('name'):
            name=descriptor['name']
        else:
            name=descriptor.get('key',' ')
        return name
        
    def get_unit_str(self,descriptor):
        if descriptor.has_key('units'):
            units=descriptor['units']
            unit_name=units.keys()[0]
        else:
            unit_name=''
            
        return unit_name
         
                         
    def make_valuewidget(self,parent,descriptor,value=None):
        """
        Returns appobriate widget with assigned value acording to
        formatting information in descriptor.
        """
        name=descriptor.get('key',' ')
        type=descriptor.get('type','text')
        mode=descriptor.get('mode','read')

        # alignment in textbox
        value_anchor=descriptor.get('value_anchor','w')
        if value_anchor=='e':
            value_justify='right'
        else:
            value_justify='left'

        # prepare validate information for entry widget
        if type=='text':
            valid=descriptor.get('valid',{})
        else:
            valid=descriptor.get('valid',{})
            valid['validator']=type

                
        if mode=='read':
            # read mode
            widget=Tkinter.Label(parent,
                                 text=' ',
                                 anchor=value_anchor,
                                 justify=value_justify,
                                 relief='sunken')
        else:
            # write mode
            widget = Pmw.EntryField(parent,
                                    validate = valid,
                                    command = self.on_applyentry,
                                    )
            # try to adjust width of entry window
            if valid.has_key('max'):
                
                if type=='text':
                    widget.component('entry').configure(
                        width=valid['max'])
                    
                elif type in ('integer','numeric'):
                    widget.component('entry').configure(
                        width=int(math.log10(abs(valid['max'])))+1)
                elif  type =='real':
                    widget.component('entry').configure(
                        width=int(math.log10(abs(valid['max'])))+4)
                    
                    
                    
        self.set_widgetvalue(widget,descriptor,value,0)
        return widget

    def get_value_from_str(self,descriptor,text,default=None):
        """
        Convert a character string in the approbriate Python value.
        """
        type=descriptor.get('type','text')
        mode=descriptor.get('mode','read')
        text=string.strip(text)
        if type =='real':
            item=string.atof(text)
            
        elif type in ('integer','numeric'):
            item=string.atoi(text)
            
        elif  type =='hexadecimal':
            item=string.atol(text,16)
            
        elif type in ('text','time','date'):
            item=text
            
        else: # entry is in read mode, return default
            print 'WARNING in get_value_from_str: unknown data type:',type
            print '  Take default value',default
            item = default
        return item
        
    def get_widgetvalue(self,widget,descriptor,default=None):
        """
        Returns data value contained in widget, already converted in the
        datatype specified in .
        If the widget is has an invalid value, the default value is set
        and returned.
        """

        #type=descriptor.get('type','text')
        mode=descriptor.get('mode','read')
        if mode=='write':
            if 1:# text/entry widget update
                #print ' Valid?',widget.valid()
                if widget.valid():
                    #print 'widget in',col_ind,row_ind,widget.get()
                    item=self.get_value_from_str(descriptor,widget.get(),
                                                 default)
                    return item
                
                else: # reset widget
                    #print 'restore',name,type
                    self.set_widgetvalue(widget,descriptor,default,
                                         set_focus_flag=0)
                    return default

        else: # entry is in read mode, return default 
            return default

    def set_widgetvalue(self,widget,descriptor,value,set_focus_flag=1):
        """
        Set value for widget, using formatting information in descriptor.
        """

        
        #print 'Gui.set_widgetvalue:',
        #print '  descriptor=',descriptor
        #print '  value=',value


        name=descriptor.get('key',' ')
        type=descriptor.get('type','text')
        mode=descriptor.get('mode','read')

        
        # text/entry widget update
        if 1: #type=='text':
            # prepare validate information for entry widget
            if type=='text':
                valid=descriptor.get('valid',{})
            else:
                valid=descriptor.get('valid',{})
                valid['validator']=type
            
            
            text=self.get_value_str(descriptor,value)
                    
            if mode=='read':
                widget.configure(text=text)
            else:
                widget.setentry(text)
                if set_focus_flag:
                    widget.component('entry').focus_set()
                    set_focus_flag=0

                
                    
        return set_focus_flag

    def get_value_str(self,descriptor,value):
        name=descriptor.get('key',' ')
        type=descriptor.get('type','text')
        mode=descriptor.get('mode','read')
        if (descriptor.has_key('printformat'))&(mode!='write'):
            #if value:
            text=descriptor['printformat']%(value)
            #    text=str(value)
        else:
            text=str(value)
        return text

    def print_dataset(self,descriptors,dataset,sep=' = '):
        for row in self.format_dataset(descriptors,dataset,sep):print row

    def print_table(self,descriptors,table,sep=' '):
        for row in self.format_table(descriptors,table,sep):print row


    def format_dataset(self,descriptors,dataset,sep=' '):
        """
        Formats dataset with descriptor as head and returns a list of
        row-strings.
        """
        stringtable=[]
        for descriptor in descriptors:
            name=self.get_descriptor_name(descriptor)
            unit=self.get_unit_str(descriptor)
            value=string.strip(\
                self.get_value_str(descriptor,dataset[descriptor['key']]))
            if unit=='':
                stringtable.append(name+sep+'='+sep+value)
            else:
                stringtable.append(name+sep+'='+sep+value+' '+unit)
        return stringtable

    def format_table(self,descriptors,table,sep=' '):
        """
        Formats table with descriptor as head and returns a list of
        row-strings.
        """
        stringtable=[]
        stringmatrix=[]
        width_max=len(descriptors)*[0]
        # get first a string matrix with all components to measure
        # column width. Then compose string for each row

        # headere line
        ind_col=0
        stringrow=[]
        for descriptor in descriptors:
            s=self.get_descriptor_name(descriptor)

            # determine max col width
            if len(s)>width_max[ind_col]:
                width_max[ind_col]=len(s)
            ind_col+=1
            stringrow.append(s)

        stringmatrix.append(copy.copy(stringrow))

        # units line
        ind_col=0
        stringrow=[]
        for descriptor in descriptors:
            s=self.get_unit_str(descriptor)
            if len(s)>0:
                s='['+s+']'

            # determine max col width
            if len(s)>width_max[ind_col]:
                width_max[ind_col]=len(s)
            ind_col+=1
            
            stringrow.append(s)

        stringmatrix.append(copy.copy(stringrow))
                
        # rows
        
        for dataset in table:
            stringrow=[]
            ind_col=0
            for descriptor in descriptors:
                if dataset.has_key(descriptor['key']):
                    s=string.strip(self.get_value_str(\
                        descriptor,dataset[descriptor['key']]))
                else:
                    s=''

                stringrow.append(s)

                # determine max col width
                if len(s)>width_max[ind_col]:
                    width_max[ind_col]=len(s)
                ind_col+=1
                
            stringmatrix.append(copy.copy(stringrow))

        #print 'format_table width_max=',width_max,len(stringmatrix)
        for stringrow in stringmatrix:
            row=''
            ind_col=0
            for s in stringrow:
                if sep==' ':
                    # format table properly with filled wite space
                    ss=string.ljust(s, width_max[ind_col]+1)
                else:
                    ss=s+sep

                row=row+ss
                ind_col+=1
                    
            stringtable.append(row)
            
        return stringtable

    def get_dataset_from_file(self,filename,descriptors,dataset={},sep='='):
        #print 'get_dataset_from_file',filename
        try:
            f=open(filename,'r')
            text=f.readlines()
            f.close()
        except:
            print 'WARNING: could not open file:',filename
            text=''

        dict_descriptors={}
        for descriptor in descriptors:
            #print '  descriptor key ',descriptor['key']
            dict_descriptors[descriptor['key']]=descriptor
        
        for line in text:
            key,valstr=string.split(line,sep)
            key=string.strip(key)
            if dict_descriptors.has_key(key):
                valstr=self.get_value_from_str(dict_descriptors[key],valstr)
                dataset[key]=valstr
                
                    
        return dataset
        
class TableEditor(Tkinter.Frame,DataSet):
    """
    Frame based widgets to edit a  table .
    """
    def __init__(self,table=[], parent = None,
                 col_descriptors=[],row_descriptors=[],
                 applybutton_command=None,applybutton_text='Ok',
                 applyentry_command=None,
                 padx=1,pady=1,
                 relief='flat',bd=0,
                 width=0,height=0):
        
        Tkinter.Frame.__init__(self,parent,
                               relief=relief,
                               bd=bd)
        self.tableframe=Pmw.ScrolledFrame(self,
                                          #labelpos = labelpos,
                                          #label_text = label_text,
                                          horizflex='expand',
                                          vertflex='expand',#**kw
                                          #usehullsize = 1,
                                          #hull_width = width,
                                          #hull_height=height,
                                          #hull_height=(len(table))*(16+pady),
                                          )
        
        
        self.gridframe=self.tableframe.interior()
        # configure size if desired, otherwise expand to available space
        self.set_size(width,height)
        

        self.applybutton_command=applybutton_command
        self.applyentry_command=applyentry_command
        #Tkinter.Button(self,text='Test',).grid(row=6,column=6)
        self.table=table
        self.table_widgets=[]
        self.row_descriptors_widgets=[]
        self.col_descriptors_widgets=[]
        self.padx=padx
        self.pady=pady

        #Tkinter.Frame.__init__(self, parent,relief=relief,bd=bd)
        if col_descriptors:
            self.col_descriptors_flag=1
            self.col_descriptors=col_descriptors
        else:
            self.col_descriptors_flag=0
            self.col_descriptors=[] 

        if row_descriptors:
            self.row_descriptors_flag=1
            self.row_descriptors=row_descriptors
        else:
            self.row_descriptors_flag=0
            self.row_descriptors=[]
        
        if len(table)>0:
            if row_descriptors:
                for row in table:
                    self.add_row(row)
            else:
                for col_ind in range(len(self.col_descriptors)):
                    col=[]
                    for row in table:
                        col.append(row[col_ind])
                    self.add_col(col)

        # finally add buttons
        if row_descriptors:
            buttons=[('Add Column', self.on_add_col),
                     ('Delete Column', self.on_del_col)]
            defaultbutton='Add Column'
        else:
            buttons=[('Add Row', self.on_add_row),
                     ('Delete Row', self.on_del_row)]
            defaultbutton='Add Row'
            
        if applybutton_command:
            buttons.append((applybutton_text,self.on_applybutton))
            defaultbutton=applybutton_text
            
        buttonbox = ButtonArray(self,
                                button_array=buttons,
                                defaultbutton=defaultbutton,
                                align=1
                                )
        buttonbox.pack(side = 'bottom', fill = 'x')
       
        self.tableframe.pack(expand=1, fill = 'both')

    def set_size(self,width=0,height=0):
        """
        Configure size if desired, otherwise expand to available space
        """
        if height>0:
            self.tableframe.component('clipper').configure(height=height)

        if width>0:
            self.tableframe.component('clipper').configure(width=width)

            
    def get_col_nr(self):
        return len(self.col_descriptors_widgets)
    
    def add_row(self,row):
        #print 'add row',row
        # label columns
        # is the number of columns (elements) in this row more
        # than the present number of columns in the table
        if len(row)>self.get_col_nr():
            
            for col_ind in range(self.get_col_nr()+1,len(row)+1):
                descriptor={}
                descriptor['key']=str(col_ind)
                descriptor['type']='text'
                descriptor['mode']='write'
                descriptors_widget=self.make_descriptorwidget(self.gridframe,
                                                        descriptor)
                
                descriptors_widget.grid(
                    row=0,column=col_ind,
                    padx=self.padx,pady=self.pady,sticky='nsew')

                self.col_descriptors_widgets.append(descriptors_widget)
                            


        # determin row index to insert row
        addrow_ind=len(self.table_widgets)

        # label row
        if self.row_descriptors_flag:
            descriptor=self.row_descriptors[addrow_ind]
            
        else:
            descriptor={}
            descriptor['key']=str(addrow_ind+1)
            descriptor['type']='text'
            descriptor['mode']='write'

        descriptors_widget=self.make_descriptorwidget(self.gridframe,
                                                      descriptor)
        descriptors_widget.grid(row=addrow_ind+1,column=0,
                                padx=self.padx,pady=self.pady,sticky='nsew')
        self.row_descriptors_widgets.append(descriptors_widget)
        
        row_widgets=[]
        col_ind=1

        # create table widgets
        for value in row:
            
            if self.col_descriptors_flag:
                descriptor=self.col_descriptors[col_ind-1]
                if len(self.table)<addrow_ind+1:
                    self.table.append(copy.copy(self.table[-1]))
                self.table[addrow_ind][col_ind-1]=copy.copy(value)

            widget=self.make_valuewidget(self.gridframe,descriptor,value)
            widget.grid(row=addrow_ind+1, column=col_ind,
                        padx=self.padx,pady=self.pady,sticky='nsew')
            
            row_widgets.append(widget)
            col_ind+=1
            
        self.table_widgets.append(row_widgets)
        self.tableframe.reposition()
   
   
    def add_col(self,col):
        #print 'add_col',len(col),self.get_col_nr()

        # Do the row labeling
        
        # is the number of rows (elements) in this column more
        # than the present number of rows in the table
        if len(col)>len(self.table_widgets)+1:
            # add/extend  enumeration of rows
            for row_ind in range(len(self.table_widgets)+1,len(col)+1):
                descriptor={}
                descriptor['key']=str(row_ind)
                descriptor['type']='text'
                descriptor['mode']='write'
                descriptors_widget=self.make_descriptorwidget(self.gridframe,
                                                        descriptor)

                descriptors_widget.grid(
                    row=row_ind,column=0,
                    padx=self.padx,pady=self.pady,sticky='nsew')

                self.row_descriptors_widgets.append(descriptors_widget)
                            
        # determin the index for inserting   
        if len(self.table_widgets)>0:
            addcol_ind=len(self.table_widgets[0])+1
        else:
            addcol_ind=1

        # do the labeling of the column to be inserted
        if self.col_descriptors_flag:
            descriptor=self.col_descriptors[addcol_ind-1]
            
        else:
            descriptor={}
            descriptor['key']=str(addcol_ind)
            descriptor['type']='text'
            descriptor['mode']='write'
            
        
        descriptors_widget=self.make_descriptorwidget(self.gridframe,
                                                      descriptor)
        descriptors_widget.grid(row=0,column=addcol_ind,
                                padx=self.padx,pady=self.pady,sticky='nsew')
        
        self.col_descriptors_widgets.append(descriptors_widget)

        # create table widgets
        row_ind=0
        for value in col:
            #print '  row_ind+1,addcol_ind,value',row_ind+1,addcol_ind,value
            if self.row_descriptors_flag:
                descriptor=self.row_descriptors[row_ind]
                self.table[row_ind].append(value)
                
            widget=self.make_valuewidget(self.gridframe,descriptor,value)
            widget.grid(row=row_ind+1, column=addcol_ind,
                        padx=self.padx,pady=self.pady,sticky='nsew')
            
            #print '  row_ind',row_ind
            #print '  len(self.table_widgets)=', len(self.table_widgets)
            if len(self.table_widgets)>row_ind:
                self.table_widgets[row_ind].append(widget)
            else:
                self.table_widgets.append([widget])
            row_ind+=1
            
        #if row_descriptors_flag:    
        #    self.col_descriptors.append(descriptor)
        self.tableframe.reposition()
        
    def get_contents(self):
        if self.row_descriptors_flag:
            row_ind=0
            for descriptor in self.row_descriptors:
                col_ind=0
                for widget in self.table_widgets[row_ind]:
                    self.table[row_ind][col_ind]=self.get_widgetvalue(
                        widget,descriptor,self.table[row_ind][col_ind])
                    col_ind+=1        
                row_ind+=1
                
        elif self.col_descriptors_flag:
            row_ind=0
            for widget_row in self.table_widgets:
                col_ind=0
                for descriptor in self.col_descriptors:
                    self.table[row_ind][col_ind]=self.get_widgetvalue(
                        widget_row[col_ind],descriptor,
                        self.table[row_ind][col_ind])
                    col_ind+=1        
                row_ind+=1

        return self.table
    
    def del_col(self):
        #print 'del_col'
        if self.get_col_nr()>1:
            delcol_ind=self.get_col_nr()-1
        
            
            self.col_descriptors_widgets[delcol_ind].destroy()
            del self.col_descriptors_widgets[delcol_ind]
            for row in self.table:
                del row[delcol_ind]

            for row_widgets in self.table_widgets:
                row_widgets[delcol_ind].destroy()
                del row_widgets[delcol_ind]


    def del_row(self):
        if len(self.table)>1:
            delrow_ind=len(self.table)-1
            
            self.row_descriptors_widgets[delrow_ind].destroy()
            del self.row_descriptors_widgets[delrow_ind]
            del self.table[delrow_ind]

            for widget in self.table_widgets[delrow_ind]:
                widget.destroy()
            del self.table_widgets[delrow_ind]        
        
    def on_add_col(self):
        col=[]
        # take last column in table
        for row in self.table:
            col.append(row[-1])
        # and create a new column with a copy of last column
        self.add_col(col)

    def on_del_col(self):
        self.del_col()

    def on_add_row(self):
        # take last row in table
        row=self.table[-1]
        #print 'on_add_row',row,self.table[-1],len(self.col_descriptors)
        self.add_row(row) # and create a new row with a copy of last row

    def on_del_row(self):
        self.del_row()
    
    def on_applyentry(self):
        if self.applyentry_command:
            self.applyentry_command(self,self.get_dataset())

    def on_applybutton(self):

        if self.applybutton_command:
            #print 'on_applybutton'
            self.applybutton_command(self.get_contents())

    
    
class DatasetEditor(Tkinter.Frame,DataSet):
    """
    Frame based widgets to edit a dataset.
    The list descriptors contains formatting information for each
    entry of the dataset.
    The dataset itself is a directory with a key-value pair for each entry.
    Dataset entries without descriptor will not be displayed.
    """
    def __init__(self,descriptors=[],dataset={}, parent = None,
                 applybutton_command=None,applybutton_text='Apply',
                 applyentry_command=None,
                 padx=1,pady=2,relief='flat',bd=0,height=0,width=0):
        
        Tkinter.Frame.__init__(self, parent,relief=relief,bd=bd)
        self.scrolledframe=Pmw.ScrolledFrame(self,
                                             horizflex='expand' ,
                                             vertflex='expand' ,#**kw
                                             )
        # configure size if desired, otherwise expand to available space
        self.set_size(width,height)
       
        self.interior=self.scrolledframe.interior()
        self.interior.configure(height=150,relief='flat')
        self.descriptors=descriptors
        
        # define cell spacing
        self.make_dataset(dataset,
                          applybutton_command,applybutton_text,
                          applyentry_command,padx,pady)
        self.scrolledframe.pack(expand=1,
                                fill='both',
                                )

    def set_size(self,width=0,height=0):
        """
        Configure size if desired, otherwise expand to available space
        """
        if height>0:
            self.scrolledframe.component('clipper').configure(height=height)

        if width>0:
            self.scrolledframe.component('clipper').configure(width=width)
            
    def make_dataset(self,dataset,
                     applybutton_command,applybutton_text,
                     applyentry_command,padx,pady):

        self.applybutton_command=applybutton_command
        self.applyentry_command=applyentry_command
        
        self.value_widgets={}
        self.buttons={}

        # set global mode to read. If write, an enter button will be generated
        self.mode='read'
        
        # initialize widgets for each entry 
        row_ind=0
        col_ind_max=0
        for descriptor in self.descriptors:
            # read and default descriptor infos
            name=descriptor.get('key',' ')
            mode=descriptor.get('mode','read')
                
            type=descriptor.get('type','text')
            name_row_ind,name_col_ind=descriptor.get(
                'name_cell',(row_ind,0))
            value_row_ind,value_col_ind=descriptor.get(
                'value_cell',(row_ind,1))

            # add buttoms to the right of entries, if desired
            if descriptor.has_key('button'):
                button_data=descriptor['button']
                #print 'make_dataset button_data:',button_data
                button_col_ind=value_col_ind+1

                botton_command=lambda self=self, name=name,:\
                     self.on_button(name)
                
                button=Tkinter.Button(self.interior,
                                      text=button_data['text'],
                                      command=botton_command,
                                      takefocus=1,
                                      )
                button.grid(row=row_ind,
                            column=button_col_ind,sticky='sw',padx=padx)
                button.bind('<Return>',self.on_button)


                # store  descriptor together with command
                # for later identification in function self.on_button
                self.buttons[name]=(descriptor,button_data['command'])
                
            else:
                button_col_ind=value_col_ind
                
            col_ind_max=max(col_ind_max,
                            name_col_ind,
                            button_col_ind,value_col_ind)

            # create empty widgets for entries,
            # also if entry is not in dataset 

            # text/entry widget creation
            if 1: #type=='text':

                # make defaults if dataset is empty for this descriptor
                if not dataset.has_key(name):
                    if type=='text':
                        data=''
                    elif type=='integer':
                        data=0
                    elif type=='real':
                        data=0.0
                    else:
                        data=None
                else:
                    data=dataset[name]
                
                name_anchor=descriptor.get('name_anchor','e')
                value_anchor=descriptor.get('value_anchor','w')
                if name_anchor=='e':
                    name_justify='right'
                    name_sticky='se'
                else:
                    name_justify='left'
                    name_sticky='sw'

                if value_anchor=='e':
                    value_justify='right'
                    value_sticky='se'
                else:
                    value_justify='left'
                    value_sticky='sw'

                
                name_widget=self.make_descriptorwidget(self.interior,
                                                       descriptor,
                                                       showunits_flag=0,
                                                       anchor=name_anchor,
                                                       justify=name_justify)
                name_widget.grid(row=name_row_ind,column=name_col_ind,
                                sticky=name_sticky,padx=padx,pady=pady)

                # frame for value and unit widget
                value_frame=Tkinter.Frame(self.interior)

                value_widget=self.make_valuewidget(value_frame,descriptor,
                                                   data)
                value_widget.grid(row=0,column=0,sticky='nswe')
                
                # pack unit into value frame if existent
                unitwidget=self.make_unitwidget(value_frame,descriptor,
                                                valuewidget=value_widget,
                                                anchor='w',
                                                justify='left',
                                                relief='flat')
                if unitwidget:
                    unitwidget.grid(row=0,column=1,sticky='nswe')
                    
                value_frame.grid(row=value_row_ind,column=value_col_ind,
                                 sticky=value_sticky,padx=0,pady=pady)

            # keep link to value_widget fo later update
            self.value_widgets[name]=value_widget
            row_ind+=1

        # store dataset
        self.dataset=dataset
                
        # add applybutton if desired
        if applybutton_command:
            applybutton=Tkinter.Button(self.interior,
                                       text=applybutton_text,
                                       command=self.on_applybutton)
            applybutton.grid(row=row_ind-1,column=col_ind_max+1,padx=10)
            applybutton.bind('<Return>',self.on_applybutton)


           
            
        self.focus()

    def update_contents(self,dataset):
        self.dataset=dataset
        set_focus_flag=1
        for descriptor in self.descriptors:
            name=descriptor.get('key','')
            if dataset.has_key(name):
                self.set_widgetvalue(self.value_widgets[name],descriptor,
                                     dataset[name])
            

    def on_button(self,name):
        """
        One of the buttons beside the entry field have been preesed.
        Figure out which one and call the respective function.
        """
        descriptor,command=self.buttons[name]
        
            
        value=self.get_widgetvalue(self.value_widgets[name],descriptor)
        # print 'on_button:',name,value ??? always shows value None, but works??
        command(self,descriptor,value)
              
                
    def on_applybutton(self,event=None):
        if self.applybutton_command:
            self.applybutton_command(self,self.get_dataset())

    def on_applyentry(self,event=None):
        if self.applyentry_command:
            self.applyentry_command(self,self.get_dataset())
        
    def get_contents(self):
        """
        Standard function to read data from widgets.
        """
        for descriptor in self.descriptors:
            name=descriptor.get('key',' ')
            self.dataset[name]=self.get_widgetvalue(self.value_widgets[name],
                                                    descriptor,
                                                    self.dataset.get(name,
                                                                     'None'))
            
                        
        return self.dataset
    
    def get_dataset(self):
        """
        Old function to read data
        """
        return self.get_contents()
                 
class Objectlibbrowser(Tkinter.Toplevel):
    """
    Generic GUI class to browse and select files
    with simulation class objects.
    """
    def __init__(self, sim, parent=None,mode='module',
                 family='test',category='track',
                 callback_on_select=None,
                 callback_on_close=None,
                 color_bg='white'):

        Tkinter.Toplevel.__init__(self,parent)
        self.protocol('WM_DELETE_WINDOW',self.close)
        
        self.sim=sim
        self.objlib_path=sim.objlib_path
        self.color_bg=color_bg
        self.callback_on_select=callback_on_select
        self.callback_on_close=callback_on_close
        self.objs=[]
        self.obj=None
        self.mode=mode

        self.title_name=string.capitalize(mode)
        self.title(self.title_name+' Browser')



        # define main interior frame
        self.toplevel = Tkinter.Frame(self)

        # selection frame ...
        self.select_group= Pmw.Group(self.toplevel,
                                     tag_text='Select '+self.title_name\
                                     +' here')
        
	self.select_group.pack(fill = 'both', expand = 1,
                               padx = 5, pady = 5,side='left')

        self.select_frame=self.select_group.interior()


        # family category selection frame ...
        
        # create dropdown family menue
        self.family_dropdown = Pmw.ComboBox(self.select_frame,
                                            label_text = 'Family:',
                                            labelpos = 'nw',
                                            selectioncommand =\
                                                      self.change_family,
                                            scrolledlist_items = \
                                                      self.get_library(''),
                                            )
	self.family_dropdown.pack(expand = 1, fill='x', padx = 5, pady = 5,
                                  side='top')

        # set default 
	self.family_dropdown.selectitem(family)

        # create dropdown category menue
        self.category_dropdown = Pmw.ComboBox(self.select_frame,
                                            label_text = 'Category:',
                                            labelpos = 'nw',
                                            selectioncommand =\
                                              self.change_category,
                                            scrolledlist_items = \
                                              self.get_library(family),
                                            )
	self.category_dropdown.pack(expand=1, fill='x', padx=5, pady=5,
                                    side='top')
        
        
        # create scrolled frame for grid with objects
        self.obj_scrolledtable=Pmw.ScrolledListBox(
            self.select_frame,
            items=(),
            labelpos='nw',
            label_text=self.title_name+'s',
            #listbox_height = 6,
            selectioncommand=self.on_highlight_obj,
            dblclickcommand=self.select_obj,
            hscrollmode='none',
            usehullsize = 1,
            hull_width = 200,
            hull_height = 1.57*200,
            )

        self.obj_scrolledtable.pack(expand=1, fill='both',side='top',
                                    padx = 5, pady = 5)

        # configure listbox...
        self.obj_box=self.obj_scrolledtable.component('listbox')
        self.obj_box.bind('<Key>',self.change_highlight)
        self.obj_box.bind('<Return>',self.select_obj)
        self.obj_box.configure(takefocus=1)
        self.obj_box.focus()
        
        # info frame ...
        self.info_group= Pmw.Group(self.toplevel,
                                   tag_text='Information on '+self.title_name)
        
	self.info_group.pack(fill = 'both', expand = 1,
                             padx = 5, pady = 5,side='right')

        self.info_frame=self.info_group.interior()
        
        # preview canvas
        self.info_scrolledcanvas = Pmw.ScrolledCanvas(self.info_frame,
                                              borderframe = 1,
                                              labelpos = 'nw',
                                              label_text = 'Preview',
                                              usehullsize = 1,
                                              hull_width = 200,
                                              hull_height = 150,
                                              )
        self.info_canvas=self.info_scrolledcanvas.interior()
        self.info_canvas.configure(bg='beige')
        
        self.info_scrolledcanvas.pack(fill = 'x', expand = 1,
                                      padx = 5, pady = 5,side='top')
        

        # Text info
        self.info_scrolledtext = Pmw.ScrolledText(self.info_frame,
                                                  borderframe = 1,
                                                  labelpos = 'nw',
                                                  label_text='No '+\
                                                  self.title_name+ ' selected',
                                                  usehullsize = 1,
                                                  hull_width = 200,
                                                  hull_height = 1.5*200,
                                                  text_padx = 10,
                                                  text_pady = 10,
                                                  text_wrap='word',
                                                  )

        self.info_scrolledtext.pack(fill = 'x', expand = 1,
                                    padx = 5, pady = 5,side='bottom')
        
        self.info_text=self.info_scrolledtext.component('text')
        self.info_text.configure(state = 'disabled')

        # finally add buttons
        buttonbox = ButtonArray(self,
                                button_array=\
                                [('Select', self.return_selected_object),
                                 ('Select and close',self.select_and_close),
                                 ('Add multiple',self.select_multiple),
                                 ('Close',self.close)],
                                defaultbutton='Select',
                                align=1
                                )
        buttonbox.pack(side = 'bottom', fill = 'x')
        
        # now pack the main frame
        self.toplevel.pack(expand=1,fill='both')
        
        # set default 
        self.change_family(family)
        self.change_category(category)
   
            
    def close(self,event=None):
        #print 'close'
        if self.callback_on_close:
            self.callback_on_close()
        self.destroy()
        
    def select_and_close(self,event=None):
        self.return_selected_object()
        self.close()
        
    def configure(self,
                  callback_on_select=None,
                  mode=None):
            
        if mode:
            self.mode=mode
            self.title_name=string.capitalize(mode)
            self.title(self.title_name+' Browser')
            
        self.callback_on_select=callback_on_select

        #print 'self.callback_on_select',self.callback_on_select

    def change_highlight(self,event):
       
        if len(self.obj_box.curselection())>0:
            ind=string.atoi(str(self.obj_box.curselection()[0]))
        else:
            ind=0
            self.obj_box.activate(str(ind))
        
        if event.keysym=='Up':
            if ind>0: ind-=1
            self.highlight_obj(self.obj_box.get(ind))
            
        elif event.keysym=='Down':
            if ind<(self.obj_box.size()-1): ind+=1
            self.highlight_obj(self.obj_box.get(ind))
        
    def on_highlight_obj(self):
        selections=self.obj_scrolledtable.getcurselection()
        if len(selections)>0:
            self.highlight_obj(selections[0])
            
    def highlight_obj(self,selection):
        self.obj=self.objs[selection]
        #print 'highlight:',self.obj.type

        
        self.info_scrolledtext.configure(label_text=self.obj.type)
        self.info_text.configure(state = 'normal')
        self.info_text.delete(1.0,'end')
        self.info_text.insert('end',self.obj.info)
        self.info_text.configure(state = 'disabled')
        
        if self.mode=='module':
            # initialize an example module of this simulation object
            editmod=self.obj.Mod(self.obj,pos=[10,10,0])
                
            # and plot it on the information canvas
            self.info_canvas.delete('all')
            self.info_scrolledcanvas.configure(
                label_text = 'Preview')
            editmod.plot(self.info_canvas)
            self.info_scrolledcanvas.resizescrollregion()

        else:
            self.info_scrolledcanvas.configure(
                label_text = 'No Preview available')
            
    def select_obj(self,event=None):
        #self.highlight_obj()
        selection=self.obj_scrolledtable.getcurselection()
        if len(selection)>0:
            self.obj=self.objs[selection[0]]
            # print 'select:',self.obj.type
            self.return_selected_object()
        

    def return_selected_object(self,event=None):
        if self.obj:
            #type=self.sim.get_type(self.family,self.category,self.obj_name)
            #print 'return_selected_object:',self.obj.type
            if self.callback_on_select:
                self.callback_on_select(self.obj.type)

    def select_multiple(self,event=None):
        if self.obj:
            #type=self.sim.get_type(self.family,self.category,self.obj_name)
            #print 'return_selected_object:',self.obj.type

            # initialize a prototype
            editmod=self.obj.Mod(self.obj,pos=[10,10,0])
            if self.callback_on_select:
                self.callback_on_select(self.obj.type,
                                        multiselect_flag=1,mod=editmod)
                
    
    def get_library(self,path):
        #print 'Check:',self.objlib_path
        if path:
            pathlist=glob.glob(
                self.objlib_path+os.sep+path+os.sep+'*')
        else:
            pathlist=glob.glob(self.objlib_path+os.sep+'*')

        #print 'pathlist=',pathlist,self.objlib_path+os.sep+'*'
        
        lib=()
        for mod in pathlist:
            item,extension=os.path.splitext(os.path.basename(mod))
            #print 'mod,item,extension',mod,item,extension
            # detect and avoid local python package and hidden files
            if (item[0]!='_')&(item[0]!='.'):
                if extension:
                    if string.upper(extension)==string.upper('.py'):
                        lib=lib+(string.lower(item),)
                else:
                    lib=lib+(string.lower(item),)
        #print 'Lib:',lib
        return lib
        
    def change_family(self,family):
        self.family=family
        #print 'family=',family

        categories=self.get_library(family)
        self.category_dropdown.setlist(categories)
        if categories:
            self.change_category(categories[0])
        else:
            self.change_category(None)
            
     
    def change_category(self,category):
        
        self.category=category
        #print 'category=',category
        if category:
            self.category_dropdown.selectitem(category)
            self.make_objlist()
        else:
            self.obj_name=''
            self.obj_scrolledtable.clear()
            
    def make_objlist(self):
        self.objs={}
        
        self.info_text.delete(1.0,'end')
        self.info_text.configure(state = 'normal')
        self.info_scrolledtext.configure(
            label_text='No '+self.title_name+' selected')
        self.info_text.configure(state = 'disabled')
        self.obj_scrolledtable.setlist(())
        self.info_canvas.delete('all')
        
        self.info_scrolledcanvas.configure(
                label_text = 'No Preview available')
        self.obj=None

        for obj_name in self.get_library(self.family+os.sep+self.category):

            # initialize object just for the purpose of reading out info
            type=self.sim.get_type(self.family,self.category,obj_name)
            #if 1: #not self.sim.obj.has_key(type):

            Obj,libs=self.sim.import_obj(type)
            obj=Obj(type,None,self.sim)
            #print 'make_objlist: try append',type
            #print '  ',self.mode,obj.multimod_flag
            if (self.mode=='object')|\
               ((self.mode=='module') & obj.multimod_flag ):
                self.objs[obj_name]=obj

        #put list in listbox
        list=self.objs.keys()
        list.sort()
        self.obj_scrolledtable.setlist(list)


class Objectlibbrowser_simple(Objectlibbrowser):
    """
    Generic GUI class to browse and select files
    with simulation class objects.
    This is a simplified version of Objectlibbrowser, where
    track elements,carrier, and user can be directly selected.
    """
    def __init__(self, sim, parent=None,mode='module',
                 group_default='Track elements',
                 callback_on_select=None,
                 callback_on_close=None,
                 color_bg='white'):

        Tkinter.Toplevel.__init__(self,parent)
        self.protocol('WM_DELETE_WINDOW',self.close)
        
        self.sim=sim
        self.objlib_path=sim.objlib_path
        self.color_bg=color_bg
        self.callback_on_select=callback_on_select
        self.callback_on_close=callback_on_close
        self.objs=[]
        self.obj=None
        self.mode=mode

        self.title_name=string.capitalize(mode)
        self.title(self.title_name+' Browser')



        # define main interior frame
        self.toplevel = Tkinter.Frame(self)

        # selection frame ...
        self.select_group= Pmw.Group(self.toplevel,
                                     tag_text='Select '+self.title_name\
                                     +' here')
        
	self.select_group.pack(fill = 'both', expand = 1,
                               padx = 5, pady = 5,side='left')

        self.select_frame=self.select_group.interior()


        # family category selection frame ...
        # HERE predefine family and category for groups
        self.groups={'Track elements':('test','track'),
                     'Carriers':('test','car'),
                     'Users':('base','user'),
                     }
                
        # create dropdown group menue
        self.dropdown = Pmw.ComboBox(self.select_frame,
                                            label_text = 'Group:',
                                            labelpos = 'nw',
                                            selectioncommand =\
                                                      self.change_group,
                                            scrolledlist_items =\
                                            ['Track elements',
                                             'Carriers',
                                             'Users'],
                                            )
	self.dropdown.pack(expand = 1, fill='x', padx = 5, pady = 5,
                           side='top')

        # set default 
	self.dropdown.selectitem(group_default)

        
        
        # create scrolled frame for grid with objects
        self.obj_scrolledtable=Pmw.ScrolledListBox(
            self.select_frame,
            items=(),
            labelpos='nw',
            label_text=self.title_name+'s',
            #listbox_height = 6,
            selectioncommand=self.on_highlight_obj,
            dblclickcommand=self.select_obj,
            hscrollmode='none',
            usehullsize = 1,
            hull_width = 200,
            hull_height = 140,
            )

        self.obj_scrolledtable.pack(expand=1, fill='both',side='top',
                                    padx = 5, pady = 5)

        # configure listbox...
        self.obj_box=self.obj_scrolledtable.component('listbox')
        self.obj_box.bind('<Key>',self.change_highlight)
        self.obj_box.bind('<Return>',self.select_obj)
        self.obj_box.configure(takefocus=1)
        self.obj_box.focus()
        
        # info frame ...
        self.info_group= Pmw.Group(self.toplevel,
                                   tag_text='Information on '+self.title_name)
        
	self.info_group.pack(fill = 'both', expand = 1,
                             padx = 5, pady = 5,side='right')

        self.info_frame=self.info_group.interior()
        
        # preview canvas
        self.info_scrolledcanvas = Pmw.ScrolledCanvas(self.info_frame,
                                              borderframe = 1,
                                              labelpos = 'nw',
                                              label_text = 'Preview',
                                              usehullsize = 1,
                                              hull_width = 200,
                                              hull_height = 100,
                                              )
        self.info_canvas=self.info_scrolledcanvas.interior()
        self.info_canvas.configure(bg='beige')
        
        self.info_scrolledcanvas.pack(fill = 'x', expand = 1,
                                      padx = 5, pady = 5,side='top')
        

        # Text info
        self.info_scrolledtext = Pmw.ScrolledText(self.info_frame,
                                                  borderframe = 1,
                                                  labelpos = 'nw',
                                                  label_text='No '+\
                                                  self.title_name+ ' selected',
                                                  usehullsize = 1,
                                                  hull_width = 200,
                                                  hull_height = 200,
                                                  text_padx = 10,
                                                  text_pady = 10,
                                                  text_wrap='word',
                                                  )

        self.info_scrolledtext.pack(fill = 'x', expand = 1,
                                    padx = 5, pady = 5,side='bottom')
        
        self.info_text=self.info_scrolledtext.component('text')
        self.info_text.configure(state = 'disabled')

        # finally add buttons
        buttonbox = ButtonArray(self,
                                button_array=\
                                [('Add', self.return_selected_object),
                                 #('Select and close',self.select_and_close),
                                 ('Add multiple',self.select_multiple),
                                 ('Close',self.close)],
                                defaultbutton='Add',
                                align=1
                                )
        buttonbox.pack(side = 'bottom', fill = 'x')
        
        # now pack the main frame
        self.toplevel.pack(expand=1,fill='both')
        
        # set default 
        self.change_group(group_default)
        
        #self.change_family(family)
        #self.change_category(category)

    def change_group(self,group):
        self.family,self.category=self.groups[group]
        self.dropdown.selectitem(group)
        #print 'category=',category
        if self.category:
            #self.category_dropdown.selectitem(category)
            self.make_objlist()
        else:
            self.obj_name=''
            self.obj_scrolledtable.clear()

    
        
class Objectbrowser(Tkinter.Toplevel):
    """
    Generic GUI class to browse and select files
    with simulation class objects.
    """
    def __init__(self, obj, parent=None,
                 family='test',category='track',
                 callback_on_select=None,
                 callback_on_close=None,
                 color_bg='white'):

        Tkinter.Toplevel.__init__(self,parent)
        self.protocol('WM_DELETE_WINDOW',self.close)

        self.obj=obj
        self.sim=obj.sim
        self.color_bg=color_bg
        self.callback_on_select=callback_on_select
        self.callback_on_close=callback_on_close

        self.title('Object browser')

        self.controlpanel=None


        # define main interior frame
        self.toplevel = Tkinter.Frame(self)

        # group with module containing objects
        #self.modobjs_group= Pmw.Group(self.toplevel,
        #                         tag_text='Current Modules')
        # 
	#self.modobjs_group.pack(fill = 'both', expand = 1,
        #                       padx = 5, pady = 5,side='top')

        #self.modobjs_frame=self.modobjs_group.interior()

        # listbox with objects
        self.objs_table=ScrolledListBox(
            self.toplevel,
            items=(),
            labelpos='nw',
            label_text='Select simulation objects',
            #listbox_height = 6,
            selectioncommand=self.on_list_mods,
            dblclickcommand=self.show_controlpanel,
            hscrollmode='none',
            usehullsize = 1,
            hull_width = 1.57*150,
            hull_height = 150,
            )

        self.objs_table.pack(expand=1, fill='both',side='left',
                                    padx = 5, pady = 5)

        #self.objs_box=self.objs_table.component('listbox')
        #self.objs_box.bind('<Key>',self.press_change_selected_objs)
        #self.objs_box.bind('<Return>',self.press_selected_objs)
        #self.objs_box.configure(takefocus=1)
        #self.objs_box.focus()

        
        # listbox with modules
        self.mods_table=ScrolledListBox(
            self.toplevel,
            items=(),
            labelpos='nw',
            label_text='Modules in selected object',
            #listbox_height = 6,
            selectioncommand=None,
            dblclickcommand=self.show_controlpanel,
            hscrollmode='none',
            usehullsize = 1,
            hull_width = 1.57*150,
            hull_height = 150,
            )

        self.mods_table.pack(expand=1, fill='both',side='right',
                                    padx = 5, pady = 5)

        # finally add buttons
        buttonbox = ButtonArray(self,
                                button_array=\
                                [('Update',
                                  self.refresh),
                                 ('Show control-panel',
                                  self.show_controlpanel),
                                 ('Show text-info',
                                  self.show_info),
                                 ('Close',self.close)],
                                defaultbutton='Show control-panel',
                                align=1
                                )
        buttonbox.pack(side = 'bottom', fill = 'x')
        
        # now pack the main frame
        self.toplevel.pack(expand=1,fill='both')
        
        # set default by updating 
        self.selection=None
        self.list_objs()

        # set keyboardfocus on objects table
        box=self.objs_table.component('listbox')
        box.configure(takefocus=1)
        box.focus()

    def refresh(self):
        self.list_objs()
        self.on_list_mods(use_current_selection_flag=1)
        
    def on_list_mods(self,use_current_selection_flag=0):
        """
        An object has been highlighted in the object listbox.
        List modules in the highlighted object.
        """
        if not use_current_selection_flag:
            self.selection=self.objs_table.get_selected_item()
        if self.selection:
            self.list_mods(self.selection)

    def on_panel_obj(self):
        """
        An object has been selected in the object listbox.
        Open control panel, if possible.
        """
        selection=self.mods_table.get_selected_item()
        if selection:
            self.activate_controlpanel(selection)

    def show_controlpanel(self):
        """
        Open control panel, if possible.
        First try whether there is a selected module
        if not show control panel of object.
        """
        selection=self.mods_table.get_selected_item()
        #print 'selected module',selection
        if selection:
            # module selected
            self.activate_controlpanel(mod_id=selection)
        else:
            selection=self.objs_table.get_selected_item()
            #print 'selected object',selection
            
            if selection:
                # object selected
                self.activate_controlpanel(obj_id=selection)
            
    def show_info(self):
        """
        Print state of selected module in terminal window.
        """
        selection=self.mods_table.get_selected_item()
        #print 'selected module',selection
        if selection:
            # module selected
            self.sim.split_id(selection)['mod'].show_info()
            
         
        #else:
        #    selection=self.objs_table.get_selected_item()
        #    #print 'selected object',selection
        #    
        #    if selection:
        #        # object selected
        #        self.activate_controlpanel(obj_id=selection)
                
        
    def close(self,event=None):
        #print 'close'
        if self.callback_on_close:
            self.callback_on_close()
        if self.obj:
            try:
                    self.obj.close_objbrowser()
            except:
                pass
            
        self.destroy()
        
    

    def activate_controlpanel(self,mod_id=None,obj_id=None):
        """
        Will activate/update the control panel.
        """
        if mod_id:
            mod=self.sim.split_id(mod_id)['mod']
            if hasattr(mod,'make_panel'):
                if not self.controlpanel:
                    self.controlpanel=Controlpanel(self,mod)
                else:     
                    self.controlpanel.update_with_target(mod)
        elif obj_id:
            obj=self.sim.split_id(obj_id)['obj']
            if hasattr(obj,'make_panel'):
                if not self.controlpanel:
                    self.controlpanel=Controlpanel(self,obj)
                else:     
                    self.controlpanel.update_with_target(obj)
                    

    def close_controlpanel(self):
            """
            This method is called when  control panel called
            is about to close.
            """
            del self.controlpanel
            self.controlpanel=None
            
            
    def list_objs(self):
        """
        Updates current list of objects.
        """

        # first Objects with modules in objs_table
        obj_list=[]
        for obj_id in self.sim.objs.keys():
            # no net objects in list...not relevant, only confusing
            if self.sim.split_id(obj_id)['category']!='net':
                obj_list.append(obj_id)

        obj_list.sort()
        self.objs_table.setlist(obj_list)
        self.mods_table.setlist(())

    def list_mods(self,obj_id):
        """
        Updates current list of modules of the specified object id.
        """
        modlist=[]
        obj=self.sim.split_id(obj_id)['obj']
        if obj:
            if obj.multimod_flag:
                for mod in obj.mods.values(): modlist.append(mod.id)
                self.mods_table.setlist(modlist)
            else:
                self.mods_table.setlist(())
        else:
            self.mods_table.setlist(())
            

class ScrolledListBox(Tkinter.Frame):
    """
    Equal to Pmw.ScrolledListBox but extended by key bindings to control
    selection.
    """
    def __init__(self,parent,selectioncommand=None,dblclickcommand=None,**kw):
        Tkinter.Frame.__init__(self,parent)
        
        self.listbox=Pmw.ScrolledListBox(self,
                                    selectioncommand=self.on_highlightcommand,
                                    dblclickcommand=self.on_selectcommand,**kw)

        self.listbox.pack(expand=1,fill='both')

        self.highlightcommand=selectioncommand
        self.selectcommand=dblclickcommand

        # set key binding
        box=self.listbox.component('listbox')
        box.bind('<Key>',self.press_change_highlight)
        box.bind('<Return>',self.press_select)
        self.sel_ind=-1

        # no keyboard focus for scrollbars...done by arrow keys
        self.listbox.component('vertscrollbar').configure(takefocus=0)
        self.listbox.component('horizscrollbar').configure(takefocus=0)

        
    def setlist(self,list):
        return self.listbox.setlist(list)
        
    def component(self,comp):
        return self.listbox.component(comp)
        
    def press_change_highlight(self,event):
        box=self.listbox.component('listbox')
        if len(box.curselection())>0:
            ind=string.atoi(str(box.curselection()[0]))
        else:
            ind=0
        box.activate(str(ind))
            
        if event.keysym=='Up':
            if ind>0: ind-=1
 
        elif event.keysym=='Down':
            if ind<(box.size()-1): ind+=1

        self.sel_ind=ind
        #print 'sel_ind=',self.sel_ind

        # determine correct index of selected item
        if self.highlightcommand:
            self.highlightcommand()
            
    def press_select(self,event):
        """
        Pressed return key.
        """
        if self.selectcommand:
            self.selectcommand()

    def on_highlightcommand(self):
        """
        Mouse click on highlight.
        """
        self.sel_ind=-1
        if self.highlightcommand:
            self.highlightcommand()

    def on_selectcommand(self):
        self.sel_ind=-1
        if self.selectcommand:
            self.selectcommand()
            
    def get_selected_item(self):
        """
        Returns correct, single selected and highlighted item.

        This is a bit messy because there is a problem with
        getting the right selected item when alternatively selected
        by mouse or keys.
        """
        
        if self.sel_ind>=0:
            #print 'last selection/highlightning by keyboard',self.sel_ind
            return self.listbox.component('listbox').get(self.sel_ind)

        else:
            #print 'last selection/highlightning by mouseclick',self.sel_ind
            selections=self.listbox.getcurselection()
            if len(selections)>0:
                return selections[0]
            else:
                return None
        
class PanedScrolledTable_old(Pmw.PanedWidget,DataSet):
    def __init__(self,parent,
                 descriptors=[],
                 table=[],
                 selectcommand=None,
                 highlightcommand=None,
                 hullwidth=1.57*200,
                 hullheight=200,
                 #relief='groove',
                 color_bg='white',
                 separatorrelief='sunken',
                 separatorthickness=2,
                 scrollbarwidth=12
                 ):
        #self.Tkinter.Frame.__init__(self,parent)
        if table:
            self.selected_ind=0
        else:
            self.selected_ind=-1
            
        self.selectcommand=selectcommand
        self.highlightcommand=highlightcommand
        
        self.color_bg=color_bg
        self.scrollbarwidth=scrollbarwidth
                
        Pmw.PanedWidget.__init__(self,parent,
                                 orient='horizontal',
                                 separatorrelief=separatorrelief,
                                 separatorthickness=separatorthickness)
        
        # configure hull
        self.component('hull').configure(width=hullwidth,
                                         height=hullheight,
                                         #relief=relief # has no effect
                                         )
        
        # initialized list for pointers to dynamic widgets 
        self.col_names=[] # label widgets above columns
        self.cols=[]  # listboxes containing all data of a column
        
        # create rightmost pane, which will always remain
        # and contain the scrollbar
        self.add('0',min=self.scrollbarwidth)

        # make scrollbar
        self.scrollbar=Tkinter.Scrollbar(self.pane(0),
                                         orient='vertical',
                                         width=self.scrollbarwidth)
        self.scrollbar.config(command=self.scrollbarview)


        # make columnbox
        boxframe=Tkinter.Frame(self.pane('0'))
        self.make_col(boxframe)
        
        #scrollbarframe.pack(expand=1,fill='y',side='right')
        self.scrollbar.pack(expand=0,fill='y',side='right')
        boxframe.pack(expand=1,fill='both',side='left')
        

        # make and fill pantable 
        self.make_table(descriptors,table)

    

    def make_table(self,descriptors,table):
        """
        Method to create and fill descriptorss and listboxes.
        Can also be used to refresh the widget as it erases previous settings.
        """
        
        col_nr=len(descriptors)
        row_nr=len(table)

        # generate or delete panes such that
        # number of panes = number of columns
        self.make_panes(col_nr)
        
        # now read table and configure widgets accordingly
        
        col_ind=0
        totalwidth=0.0
        for descriptor in descriptors:
            # determine  total table width from column width
            # given in descriptors
            if descriptor.has_key('width'):
                totalwidth+=descriptor['width']
            else:
                totalwidth+=1

            # set column name to label widget
            if descriptor.has_key('type'):
                col_name=descriptor['type']
            else:
                col_name=descriptor['name']
            #
            unit_str=self.get_unit_str(descriptor)
            if unit_str:
                self.col_names[col_ind].configure(text=col_name+' ['+
                                                 self.get_unit_str(descriptor)+
                                                  ']')
            else:
                self.col_names[col_ind].configure(text=col_name)

            # take listbox widget of this column and fill it with rows
            col=self.cols[col_ind]
            for row_ind in range(row_nr):
                if table[row_ind].has_key(col_name):
                    if descriptor.has_key('printformat'):
                        text=descriptor['printformat']%table[row_ind][col_name]
                    else:
                        text=str(table[row_ind][col_name])
                else:
                    text='None'
                        
                col.insert('end',text)

            col_ind+=1

        # adjust width of panes
        zero_ind=string.atoi(self.panes()[0])
        pane_ind=zero_ind # index of leftmost pane
        for descriptor in descriptors[0:-1]:
            if descriptor.has_key('width'):
                self.configurepane(str(pane_ind),
                                   size=(descriptor['width']/totalwidth))

            pane_ind+=1
        

        # set focus on first listbox
        self.pane(str(zero_ind)).focus()
        
    def make_panes(self,col_nr):
        """
        Add or delete pane widgets, labels and listboxes to fit
        exactly col_nr columns.
        """

        # empty all listboxes 
        self.clear_cols()
        panes_nr=len(self.panes())
        if panes_nr<col_nr:
            # add panes to the left
            while len(self.panes())!=col_nr:
                # create pane to the left with decreasing, negative index
                zero_ind=string.atoi(self.panes()[0])
                pane=self.insert(str(zero_ind-1))
                self.make_col(pane)
                
        elif (panes_nr>col_nr)&(panes_nr>1):
            # delete panes from left untill there are exactly col_nr panes.
            while len(self.panes())!=col_nr:
                self.delete(self.panes()[0])
                self.col_names.pop(0)
                self.cols.pop(0)

        #self.cols[0].configure(takefocus=1)
        self.cols[-1].focus()
                
    def make_col(self,parent):
        """
        Create column widgets and returns label widget with column name
        and listbox widget containing column information...when filled.
        """
        col_name=Tkinter.Label(parent,
                               #bg=color_bg,
                               bd=0,
                               relief='flat',
                               text='')
        
        col_name.pack(fill='x',side='top')
        
        # keep link to widget
        self.col_names.insert(0,col_name)

        col=Tkinter.Listbox(parent,
                            bg=self.color_bg,
                            bd=0,
                            exportselection=0,
                            takefocus=1,
                            )
        
        col.pack(fill='x',side='top')
        

        # tie scollbar to this listbox
        col.configure(yscrollcommand=self.scrollbar.set)
        col.bind('<Up>',self.change_keyselection)
        col.bind('<Down>',self.change_keyselection)
        col.bind('<Button-1>',self.change_mouseselection)
        col.bind('<Return>',self.on_select)
        col.bind('<Double-1>',self.on_select)
        
        # keep link to widget
        self.cols.insert(0,col)
        
    def scrollbarview(self,*args):
        for col in self.cols:
            #apply(listbox.yview,args)
            col.yview(*args)

   
    def on_select(self,event):
        selectedlistbox=event.widget
        #print 'on_keyselect',selectedlistbox.curselection()
        selection=selectedlistbox.curselection()
        if len(selection)>0:
            ind=string.atoi(str(selection[0]))
            #print 'Select',ind

            # execute... 
            if self.selectcommand:
                self.selectcommand(ind)

        
    def change_mouseselection(self,event):
        selectedlistbox=event.widget
        selectedlistbox.focus()
        ind=selectedlistbox.nearest(event.y)
        self.make_selection(selectedlistbox,ind)
        
            
    def change_keyselection(self,event):
        selectedlistbox=event.widget

        if len(selectedlistbox.curselection())>0:
            ind=string.atoi(str(selectedlistbox.curselection()[0]))
        else:
            ind=0
        
        if event.keysym=='Up':
            if ind>0: ind-=1
                        
        elif event.keysym=='Down':
            if ind<(selectedlistbox.size()-1): ind+=1

        self.make_selection(selectedlistbox,ind)

    def make_selection(self,selectedlistbox,ind):

        # select same row in all listboxes
        for listbox in self.cols:
            if  listbox!=selectedlistbox:
                listbox.select_clear(0,'end')
                listbox.activate(str(ind))
                listbox.see(ind)
                listbox.select_set(ind)

        # execute... 
        if self.highlightcommand:
            self.highlightcommand(ind)

        self.selected_ind=ind
            
    def get_selection_ind(self):
        """
        Get index of currently selected line.
        """
        return self.selected_ind
    
    def clear_cols(self):
        """
        Clear contents of column listboxes.
        """
        for col in self.cols: col.delete(0,'end')

        
class PanedScrolledTable(Pmw.PanedWidget,DataSet):
    def __init__(self,parent,
                 descriptors=[],
                 table=[],
                 selectcommand=None,
                 highlightcommand=None,
                 hullwidth=0,
                 hullheight=0,
                 #relief='groove',
                 color_bg='white',
                 separatorrelief='sunken',
                 separatorthickness=2,
                 scrollbarwidth=12
                 ):
        #self.Tkinter.Frame.__init__(self,parent)
        self.selectcommand=selectcommand
        self.highlightcommand=highlightcommand
        if table:
            self.selected_ind=0
        else:
            self.selected_ind=-1
        
        self.color_bg=color_bg
        self.scrollbarwidth=scrollbarwidth
                
        Pmw.PanedWidget.__init__(self,parent,
                                 orient='horizontal',
                                 separatorrelief=separatorrelief,
                                 separatorthickness=separatorthickness,
                                 #hull_width=300,
                                 #hull_height=300
                                 )
        
        # configure hull
        if hullwidth>0:
            self.component('hull').configure(width=hullwidth)

        if hullheight>0:
            self.component('hull').configure(height=hullheight)
        #                                 height=hullheight,
        #                                 #relief=relief # has no effect
        #                                 )
        
        # initialized list for pointers to dynamic widgets 
        self.col_names=[] # label widgets above columns
        self.cols=[]  # listboxes containing all data of a column
        
        # create rightmost pane, which will always remain
        # and contain the scrollbar
        self.add('0',min=self.scrollbarwidth)

        # make scrollbar
        self.scrollbar=Tkinter.Scrollbar(self.pane(0),
                                         orient='vertical',
                                         width=self.scrollbarwidth)
        self.scrollbar.config(command=self.scrollbarview)


        # make columnbox
        boxframe=Tkinter.Frame(self.pane('0'))
        self.make_col(boxframe)
        
        #scrollbarframe.pack(expand=1,fill='y',side='right')
        self.scrollbar.pack(expand=0,fill='both',side='right')
        boxframe.pack(expand=1,fill='both',side='left')
        

        # make and fill pantable 
        self.make_table(descriptors,table)

    

    def make_table(self,descriptors,table):
        """
        Method to create and fill descriptorss and listboxes.
        Can also be used to refresh the widget as it erases previous settings.
        """
        
        col_nr=len(descriptors)
        row_nr=len(table)

        # generate or delete panes such that
        # number of panes = number of columns
        self.make_panes(col_nr)
        
        # now read table and configure widgets accordingly
        
        col_ind=0
        totalwidth=0.0

        # check first if there is a unit information in any of the columns
        # in this case all headings must have two lines
        unit_flag=0
        for descriptor in descriptors:
            if self.get_unit_str(descriptor):unit_flag=1
                
            
        for descriptor in descriptors:
            # determine  total table width from column width
            # given in descriptors
            if descriptor.has_key('width'):
                totalwidth+=descriptor['width']
            else:
                totalwidth+=1

            # set column name to label widget
            if descriptor.has_key('name'):
                col_name=descriptor['name']
            else:
                col_name=descriptor['key']
            col_key=descriptor['key']
                
            unit_str=self.get_unit_str(descriptor)
            if unit_str:
                self.col_names[col_ind].configure(text=col_name+'\n ['+
                                                 self.get_unit_str(descriptor)+
                                                  ']')
            else:
                if unit_flag:
                    # this column has no unit, but some  have
                    # -> insert an extra blank line to all columns aligned 
                    self.col_names[col_ind].configure(text=col_name+'\n ')
                else:
                    self.col_names[col_ind].configure(text=col_name)
                    
            # take listbox widget of this column and fill it with rows
            col=self.cols[col_ind]
            for row_ind in range(row_nr):
                if table[row_ind].has_key(col_key):
                    if descriptor.has_key('printformat'):
                        text=descriptor['printformat']%table[row_ind][col_key]
                    else:
                        text=str(table[row_ind][col_key])
                else:
                    text='None'
                        
                col.insert('end',text)

            col_ind+=1

        # adjust width of panes
        zero_ind=string.atoi(self.panes()[0])
        pane_ind=zero_ind # index of leftmost pane
        for descriptor in descriptors[0:-1]:
            if descriptor.has_key('width'):
                self.configurepane(str(pane_ind),
                                   size=(descriptor['width']/totalwidth))

            pane_ind+=1
        

        # set focus on first listbox
        self.pane(str(zero_ind)).focus()

        # select previous selection, if possible
        if  len(table)>0:
            if (self.selected_ind<len(table))&(self.selected_ind>=0):
                self.make_selection(None,self.selected_ind)
            else:
                self.selected_ind=0
                self.make_selection(None,self.selected_ind)
        else:
            self.selected_ind=-1
            
    def make_panes(self,col_nr):
        """
        Add or delete pane widgets, labels and listboxes to fit
        exactly col_nr columns.
        """

        # empty all listboxes 
        self.clear_cols()
        panes_nr=len(self.panes())
        if panes_nr<col_nr:
            # add panes to the left
            while len(self.panes())!=col_nr:
                # create pane to the left with decreasing, negative index
                zero_ind=string.atoi(self.panes()[0])
                pane=self.insert(str(zero_ind-1))
                self.make_col(pane)
                
        elif (panes_nr>col_nr)&(panes_nr>1):
            # delete panes from left untill there are exactly col_nr panes.
            while len(self.panes())!=col_nr:
                self.delete(self.panes()[0])
                self.col_names.pop(0)
                self.cols.pop(0)

        #self.cols[0].configure(takefocus=1)
        self.cols[-1].focus()
                
    def make_col(self,parent):
        """
        Create column widgets and returns label widget with column name
        and listbox widget containing column information...when filled.
        """
        col_name=Tkinter.Label(parent,
                               #bg=color_bg,
                               bd=0,
                               relief='flat',
                               text='')
        
        col_name.pack(expand=0,fill='x',side='top')
        
        # keep link to widget
        self.col_names.insert(0,col_name)

        col=Tkinter.Listbox(parent,
                            bg=self.color_bg,
                            bd=0,
                            exportselection=0,
                            takefocus=1,
                            )
        
        col.pack(expand=1,fill='both',side='top')
        

        # tie scollbar to this listbox
        col.configure(yscrollcommand=self.scrollbar.set)
        col.bind('<Up>',self.change_keyselection)
        col.bind('<Down>',self.change_keyselection)
        col.bind('<Button-1>',self.change_mouseselection)
        col.bind('<Return>',self.on_select)
        col.bind('<Double-1>',self.on_select)
        
        # keep link to widget
        self.cols.insert(0,col)
        
    def scrollbarview(self,*args):
        for col in self.cols:
            #apply(listbox.yview,args)
            col.yview(*args)

   
    def on_select(self,event):
        selectedlistbox=event.widget
        #print 'on_keyselect',selectedlistbox.curselection()
        selection=selectedlistbox.curselection()
        if len(selection)>0:
            ind=string.atoi(str(selection[0]))
            self.selected_ind=ind
            #print 'Select',ind

            # execute... 
            if self.selectcommand:
                self.selectcommand(ind)

        
    def change_mouseselection(self,event):
        selectedlistbox=event.widget
        selectedlistbox.focus()
        ind=selectedlistbox.nearest(event.y)
        self.make_selection(selectedlistbox,ind)
        
            
    def change_keyselection(self,event):
        selectedlistbox=event.widget

        if len(selectedlistbox.curselection())>0:
            ind=string.atoi(str(selectedlistbox.curselection()[0]))
        else:
            ind=0
        
        if event.keysym=='Up':
            if ind>0: ind-=1
                        
        elif event.keysym=='Down':
            if ind<(selectedlistbox.size()-1): ind+=1

        self.make_selection(selectedlistbox,ind)

    def make_selection(self,selectedlistbox,ind):

        # select same row in all listboxes
        for listbox in self.cols:
            if  listbox!=selectedlistbox:
                listbox.select_clear(0,'end')
                listbox.activate(str(ind))
                listbox.see(ind)
                listbox.select_set(ind)

        # execute...
        if self.highlightcommand:
            self.highlightcommand(ind)

        self.selected_ind=ind

    def get_selection(self,col_ind):
        """
        Returns selected item(s) in the listbox of column col_id.
        """
        return self.cols[col_ind].get(self.selected_ind)
        
    def get_selection_ind(self):
        """
        Get index of currently selected line.
        """
        return self.selected_ind
        
    def clear_cols(self):
        """
        Clear contents of column listboxes.
        """
        for col in self.cols: col.delete(0,'end')


class ButtonArray(Pmw.ButtonBox):
    """
    This widget is based on ButtonBox, but binds the return-key to the
    buttons. It further allows the initialization of the buttons
    during initialization by the button_array list:
    button_array=[('button_name_1',callback_command_1), ...]
    
    Importan!!: the callback_commands MUST accept one OPTIONAL argument,
    which will be the event widget, in case the enter button
    has been pressed.

    Also a defaultbutton can be specified.
    With align=1 all buttons will have the same size.
    """
    
    def __init__(self,parent=None,
                 button_array=[],
                 defaultbutton='',
                 align=1,**kw):
       
        Pmw.ButtonBox.__init__(self,parent,**kw)

        self.commands={}
        for button_data in button_array:
            if len(button_data)==2:
                name,command = button_data
                self.commands[name]=(command,)
            elif len(button_data)==3:
                name,command,args = button_data
                self.commands[name]=(command,args)
            b=self.add(name,
                       command=lambda self=self, \
                                      name=name: self._on_press(name))
            b.bind('<Return>',self._on_return)

        if defaultbutton:
            self.defaultbutton_name=defaultbutton
            self.setdefault(defaultbutton)
            self.bind('<Return>', self._on_press_default)
            
        if align:
            self.alignbuttons(when='later')
            
    def _on_press(self,name):
        #print '_on_press',name,self.commands[name]
        if name:
            if len(self.commands[name])==2:
                func,args=self.commands[name]
                func(**args)
            elif len(self.commands[name])==1:
                func=self.commands[name][0]
                func()
                
    def _on_press_default(self,event):
        self._on_press(self.defaultbutton_name)

    def  _on_return(self,event):
        self._on_press(event.widget['text'])
    
class ScrolledTable(Pmw.ScrolledFrame):
    def __init__(self,parent=None,
                 callback_on_select=None,
                 callback_on_highlight=None,
                 label_text=None,
                 labelpos=None,
                 color_bg='grey85',
                 color_highl='grey90',
                 highl_mode='field', # or row
                 highl_event='click', # or click
                 **kw):

        self.callback_on_select=callback_on_select
        self.callback_on_highlight=callback_on_highlight
        self.fields={}
        self.row_inds=[]
        self.color_bg=color_bg
        self.color_highl=color_highl
        self.highl_mode=highl_mode
        self.highl_event=highl_event
        self.widget_highlighted=None
        self.highlight_changed=0
        
        Pmw.ScrolledFrame.__init__(self,parent,
                                   labelpos = labelpos,
                                   label_text = label_text,
                                   horizflex='fixed',
                                   vertflex='fixed',**kw
                                   )
        

        self.scrolled_frame=self.interior()
        #self.scrolled_frame=self.component('frame')
        #self.component('hull').configure(bg=color_bg)
        #self.scrolled_frame.configure(bg=color_bg)
        self.vertscrollbar=self.component('vertscrollbar')
        self.horizscrollbar=self.component('horizscrollbar')
        
        # bind stuff on frame:
        self.scrolled_frame.bind('<Return>',self.on_return)
        self.scrolled_frame.bind('<Up>',self.on_up)
        self.scrolled_frame.bind('<Down>',self.on_down)
        self.scrolled_frame.bind('<Left>',self.on_left)
        self.scrolled_frame.bind('<Right>',self.on_right)
        self.scrolled_frame.configure(takefocus=1)
        self.scrolled_frame.bind('<Enter>',self.on_enter_frame)
        self.scrolled_frame.focus()

    
    def put(self,row_ind,col_ind,Widgetclass,
            padx=0,
            pady=0,
            columnspan=1,
            rowspan=1,
            sticky = 'nsew',
            imagefile_name=None,**kw):

        field={'widget':Widgetclass(self.scrolled_frame,kw)}

        # put image on field if there is an image file defined
        if imagefile_name:
            photoimage=Tkinter.PhotoImage(file=imagefile_name)
            type=Widgetclass.__name__
            if type=='Canvas':
                field['widget'].config(width=photoimage.width()+2,
                         height=photoimage.height()+2)
                field['widget'].create_image(0,0,image=photoimage,anchor='nw')
                field['image']=photoimage
            
            elif (type=='Button')|(type=='Label'):
                
                field['widget'].config(image=photoimage) 
                field['image']=photoimage
                
        # bind  some events to the field
        field['widget'].bind('<Enter>',self.on_enter)
        field['widget'].bind('<Leave>',self.on_leave)
        field['widget'].bind('<Button-1>',self.on_click)

        if self.callback_on_select:
            field['widget'].bind('<Double-1>',self.on_doubleclick)
                

        # store data of this field
        if self.fields.has_key(row_ind):
            row=self.fields[row_ind]
            row[col_ind]=field

        else:
            self.fields[row_ind]={col_ind:field}


        self.row_inds=self.fields.keys()
        self.row_inds.sort()

        
        field['widget'].grid(row = row_ind,
                             col = col_ind,
                             padx=padx,
                             pady=pady,
                             columnspan=columnspan,
                             rowspan=rowspan,
                             sticky = sticky)
        
        self.scrolled_frame.grid_rowconfigure(row_ind, weight = 1)
	self.scrolled_frame.grid_columnconfigure(col_ind, weight = 1)

        
        self.reposition()

    #def get_key(self,row_ind,col_ind):
    #    return `row_ind`+','+`col_ind`

    #def get_index(self,key):
    #    
    #    row_string,col_string=string.split(key,',')
    #    return string.atoi(row_string),string.atoi(col_string)
    
    def clear(self):

        for row_ind in self.fields.keys():
            row=self.fields[row_ind]
            for col_ind in row.keys():
                row[col_ind]['widget'].destroy()
                del row[col_ind]
            if not row:
                del self.fields[row_ind]
                
        self.widget_highlighted=None
        self.row_inds=[]
        self.reposition()
        
    def on_enter_frame(self,event):
        self.scrolled_frame.focus()
        
    def on_enter(self,event):
        if self.highl_event=='over':
            self.highlight(event.widget)
        
    def on_leave(self,event):
        pass
        #if self.highl_event=='over':
        #    self.unhighlight()

    def on_up(self,event):
        self.highlight(self.get_next_widget(self.widget_highlighted,
                                            row_inc=-1))
        self.reposition_vertscrollbar(row_inc=-1)
        
    def on_down(self,event):
        self.highlight(self.get_next_widget(self.widget_highlighted,
                                            row_inc=+1))
        self.reposition_vertscrollbar(row_inc=+1)

    def on_left(self,event):
        self.highlight(self.get_next_widget(self.widget_highlighted,
                                            col_inc=-1))
        self.reposition_horizscrollbar(col_inc=-1)
        
    def on_right(self,event):
        self.highlight(self.get_next_widget(self.widget_highlighted,
                                            col_inc=+1))
        self.reposition_horizscrollbar(col_inc=+1)
      
        
    def reposition_vertscrollbar(self,row_inc=+1):
        row_ind,col_ind=self.get_index(self.widget_highlighted)
        pos=1.0*row_ind/len(self.row_inds)
        pos_lo,pos_hi=self.vertscrollbar.get()
        if (pos>pos_hi)|(pos<pos_lo):
            if row_inc>0:
                self._yview('moveto',pos)
            else:
                pos=pos-(pos_hi-pos_lo)
                if pos<=0: pos=0
                self._yview('moveto',pos)

        #print 'scrollbar:',pos_lo,pos_hi
        #print 'widget_highlighted:',pos

        #for key in widget.keys():
        #    try:
        #        val=widget.cget(key)
        #    except:
        #        val='no info'
        #    print 'moreinfo key',key,'=',val
   
        
    def reposition_horizscrollbar(self,col_inc=+1):
        row_ind,col_ind=self.get_index(self.widget_highlighted)
        col_nr,row_nr=self.scrolled_frame.grid_size()
        pos=1.0*col_ind/col_nr
        pos_lo,pos_hi=self.horizscrollbar.get()
        if (pos>pos_hi)|(pos<pos_lo):
            if col_inc>0:
                self._xview('moveto',pos)
            else:
                pos=pos-(pos_hi-pos_lo)
                if pos<=0: pos=0
                self._xview('moveto',pos)
        
    def get_index(self,widget):
        info=widget.grid_info()
        return string.atoi(info['row']),string.atoi(info['column'])
        
    

    def get_next_widget(self,widget=None,row_inc=0,col_inc=0):
        if widget:
            row_ind,col_ind=self.get_index(widget)

        else:
            row_ind=self.row_inds[0]
            col_ind=self.fields[row_ind].keys()[0]
            
        if row_inc!=0:
            ind=self.row_inds.index(row_ind)+row_inc
            if ind < 0:
                nextrow_ind=self.row_inds[0]

            elif ind>len(self.row_inds)-1:
                nextrow_ind=self.row_inds[-1]

            else:
                nextrow_ind=self.row_inds[ind]
        else:
            nextrow_ind=row_ind

        col_inds=self.fields[nextrow_ind].keys()
        col_inds.sort()
        if self.fields[nextrow_ind].has_key(col_ind+col_inc):
            ind=col_inds.index(col_ind)+col_inc    
        
            if ind < 0:
                nextcol_ind=self.col_inds[0]

            elif ind>len(col_inds)-1:
                nextcol_ind=col_inds[-1]

            else:
                nextcol_ind=col_inds[ind]
        else:
            if col_inc>0:
                nextcol_ind=col_inds[-1]
            else:
                nextcol_ind=col_inds[0]

        return self.fields[nextrow_ind][nextcol_ind]['widget']
        
    def on_click(self,event):
        if self.highl_event=='over':
            self.on_select(event.widget)
        else:
            self.highlight(event.widget)

    def on_doubleclick(self,event):
        self.highlight(event.widget,callback=0)
        self.on_select(event.widget)


    def on_return(self,event):
        if self.widget_highlighted:
            self.on_select(self.widget_highlighted)
            
    def on_select(self,widget):
        row_ind,col_ind=self.get_index(widget)
        self.callback_on_select(row_ind,col_ind,
                                self.fields[row_ind][col_ind])

        
    def highlight(self,widget,callback=1):
        
        if widget!=self.widget_highlighted:
            self.highlight_changed=1
            row_ind,col_ind=self.get_index(widget)
            if self.highl_mode=='row':
                if self.widget_highlighted:
                    oldrow_ind,oldcol_ind=self.get_index(
                        self.widget_highlighted)
                    if oldrow_ind==row_ind: self.highlight_changed=0
        else:
            self.highlight_changed=0
                

        if self.highlight_changed & callback:
            if self.callback_on_highlight:
                row_ind,col_ind=self.get_index(widget)
                self.callback_on_highlight(row_ind,col_ind,
                                           self.fields[row_ind][col_ind])
                
        
        if self.highlight_changed:
            self.unhighlight()
            self.widget_highlighted=widget
            if self.highl_mode=='field':
                widget.config(bg=self.color_highl)
            elif self.highl_mode=='row':
                for field in self.fields[row_ind].values():
                    field['widget'].config(bg=self.color_highl)
        
        
    def unhighlight(self):
        if self.widget_highlighted:
            
            if self.highl_mode=='field':
                self.widget_highlighted.config(bg=self.color_bg)
            elif self.highl_mode=='row':
                row_ind,col_ind=self.get_index(self.widget_highlighted)
                for field in self.fields[row_ind].values():
                    field['widget'].config(bg=self.color_bg)

       



            
    
class Valuetable(Tkinter.Frame):
    """
    Frame based widgets to display a simple list of
    (quantityname,value,unit) tuples in a table.
    """
    def __init__(self,list=[], parent = None):
        Tkinter.Frame.__init__(self, parent)
        self.widgetlist=[]
        self.update_contents(list)

    def update_contents(self,list):

        # clear and reinitialize widgets if table size changed
        if len(list)!=len(self.widgetlist):
            # clear table
            for widgets in self.widgetlist:
                for widget in widgets: widget.destroy()
                self.widgetlist=[]
                
            # initialize widgets
            row_ind=0
            padx=1
            pady=2
            for entry in list:
                namewidget=Tkinter.Label(
                    self,text=' ',anchor='e',justify='right')
                namewidget.grid(row=row_ind,column=0,
                                sticky='se',padx=padx,pady=pady)
                
                valuewidget=Tkinter.Label(self,text=' ',
                                          anchor='w',justify='left',
                                          relief='sunken')
                valuewidget.grid(row=row_ind,column=1,
                                 sticky='sw',padx=0,pady=pady)
            
                self.widgetlist.append((namewidget,valuewidget))
            
                row_ind+=1
                
        # fill table
        row_ind=0
        for entry in list:
            # read table
            if len(entry)==2:
                name,value=entry
                unit=''
            elif len(entry)>=3:
                name,value,unit=entry

            # configure widgets
            namewidget,valuewidget=self.widgetlist[row_ind]
            
            namewidget.configure(text=name+' :')
            valuewidget.configure(text=str(value)+' '+str(unit))
        
            row_ind+=1
                
  
        
    
    
