if __name__ == '__build__':
	raise Exception

###############################################################################
# IMPORTS
from classlib.base import *
import Pmw, copy
import Tkinter,tkMessageBox,tkFileDialog,os,string
import sys
from OpenGL.GL import *
from OpenGL.GLE import *
from OpenGL.GLUT import *
from Numeric import *
from RandomArray import *
from LinearAlgebra import determinant
###############################################################################


class Netmon_gl(Obj):
    """
    3D Net monitor, using OpenGL.
    """
    
    def init_obj(self):
        #self.gui_flag=1  # initialize ONLY in gui simulation mode
        self.output_interval=0.1 # seconds
        #if (not self.sim.objs.has_key(self.type))&\
        #       (self.sim.mode=='gui'):
        
        
        
	#self.make_pole= self.make_pole_arc
	self.make_pole= self.make_pole_round
	#self.make_pole= self.make_portici

	# does not work yet: self.make_pole= None
        
	self.show_users_flag=0
	
        self.color_ground=(0.2,0.8,0.2,1.0)
        self.color_sky=(0.7,0.8,0.9,1.0)
        self.color_track=[0.6,0.6,0.8, 1.0]

	
	self.color_users=[0.8,0.8,0.8, 1.0]
	
        self.dist_poles=20.0
		


        #self.color_grid=[0.4,1.0,0.4,1.0]
        self.color_grid=[0.9,1.0,0.9,1.0]
        self.width_grid=50.0
        
	#viewer position
	self.x=-200.0
	self.y=-200.0
	self.z=-300.0

	self.step=1.0
	
	# viewing angle
	self.alpha_y=0.0
	self.alpha_z=0.0

	self.alpha_step=1.0

	# carrier s view. These are stored to creat5e a filter
	# when user sits on a carrier
	self.alpha_z_user=0.0
	self.alpha_z_user_lastcurrent=0.0
	self.view_user=array([0.0,0.0,0.0])
	self.lambda_user=0.90

	self.z_user=1.5 # user z position
	
	
        # initial mouse position
        self.x_mouse = 0
        self.y_mouse = 0

	# box extremities of track
	# will be adapted in adjust_box()
	self.box_max=-10.0**9*array((1.0,1.0,1.0))
	self.box_min=10.0**9*array((1.0,1.0,1.0))
	self.box_center=0.0*array((1.0,1.0,1.0))
	
	# name of view can be user,...
        self.view=''

        # main array index count
        self.ind_array=0
        
    def get_state(self):
        '''Prepare state image for save operation'''
        
        # do the following  actions only in gui mode

        if self.sim.mode=='gui':
            # delete bitmaps to safe memory
            pass
        

        else:
            # recover map info for non-gui-mode
            #maps_save=self.maps
            pass
        
        return {}

    def set_state(self,state_image):
        # do the following init actions only in gui mode
        if self.sim.mode=='gui':
            pass

        else:
            # simulation is in non-gui mode
            # this is just to store the map info somewhere till it gets saved
            pass
    
    def set_poletype(self,polename):
	    """
	    Set pole function generator
	    """
	    print 'set_poletype',polename
	    if polename=='round':
		    self.make_pole=self.make_pole_round
	    elif polename=='arc':
		    self.make_pole=self.make_pole_arc
	    elif polename=='portici':
		    
		    self.make_pole=self.make_portici
	    else:
		    print 'ERROR: no valid pole name:',polename
		    sys.exit(2)
		    
	    
    def close(self):
        """
        Does necessary action before this simulation object is
        deleted from memory.

        It can be assumed that the state of the object has been
        saved. So what remains is to clear up other things, essentially
        GUI stuff, for example Menues in simwin
        """
        pass


    def link(self):
        #print 'link',self.id
        self.netsim=self.try_link_with('base.net.netsim')
	self.users=self.try_link_with('base.user.test_driver')
	if not self.users:
		self.users=self.try_link_with('base.user.generic')
	

	if self.users:
		# increase update frequency (quick and dirty)
		self.users.iterate_interval=0.5 # second update
	else:
		self.show_users_flag=0
		
	
        #self.netedit_gui=self.try_link_with('base.net.netedit_gui')
        if self.netsim:
		points,faces,colors=self.read_glfile(
			'objlib/test/car/experim.ogl',
			0.02,0.02,0.02)
		

		(self.vertex,
		 self.color,
		 self.norm,
		 self.range_car)=self.get_trianglematices(points,faces,colors,0)


		# create a nice intersection of the track
		# first create a half circle
		phi=arange(pi/2.0,-pi/2.0-pi/5.0,-pi/5.0)
		x_circ=0.25*transpose([cos(phi)])
		y_circ=0.25*transpose([sin(phi)])
		#halfcirc_right=concatenate(\
		#	(transpose([x_circ]),transpose([y_circ])),axis=1)
		#halfcirc_left=concatenate(\
		#	(transpose(-[x_circ]),transpose([y_circ])),axis=1)

		#intersection= concatenate(
		#	(concatenate((-0.80-x_circ,-0.25+y_circ),axis=1),
		#	 concatenate((0.80+x_circ,-0.25-y_circ),axis=1),
		#	 [[0.50,0.0],[0.50,-0.40],[-0.50,-0.4],[-0.50,-0.0],],
		#	 ),axis=0)

                
		#intersection=[(-0.80,0.0),(-0.80,-0.5),(0.80,-0.5),(0.80,0.0),
		#	      (0.50,0.0),(0.50,-0.30),
		#	      (-0.50,-0.30),(-0.50,0.0),
		#	      ]

		#intersection=[(-0.70,0.0),(-0.80,-0.7),(-0.80,-0.5),
                #              (0.80,-0.5),(0.80,-0.1),(0.70,0.0),
		#	      (0.50,0.0),(0.50,-0.30),
		#	      (-0.50,-0.30),(-0.50,0.0),
		#	      ]
		intersection=[(-0.70,0.0),(-0.80,-0.1),(-0.80,-0.5),
                              (0.80,-0.5),(0.80,-0.1),(0.70,0.0),
			      (0.50,0.0),(0.50,-0.20),
			      (-0.50,-0.20),(-0.50,0.0),
			      ]
		
		
		
		#print 'intersection=',intersection
		
		#reshape(concatenate((x_circ,y_circ),axis=0),(len(x_circ),2))

		self.make_trackmatices(intersection)

		
		self.make_user_arrays()
    	
		# set the display mode and create the window
		glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH)
		glutCreateWindow(self.sim.simfile_name+'- OpenGL monitor')
		#glutCreateWindow("GLE demo")
	
		#print 'open win'
        
		# setup the callbacks
		glutDisplayFunc(self.on_display)
		glutMotionFunc(self.on_motion)
		glutReshapeFunc(self.on_reshape)
		#glutTimerFunc(5000,self.loop_gl,0)
		glutIdleFunc(self.loop_gl)
		# Register the function called when the keyboard is pressed.  
		glutKeyboardFunc(self.on_key_pressed)
		# 
		glClearDepth(1.0)
		glEnable(GL_DEPTH_TEST)

		glClearColor(0.0, 0.0, 0.0, 0.0)
		#glClearColor(0.5, 0.7, 0.9, 1.0) #skyblue
		glShadeModel(GL_SMOOTH)
        
		glMatrixMode(GL_MODELVIEW)

		

		# set up a light
		#print 'self.box_center=',self.box_center
		lightOnePosition =( self.box_center[0],
				    self.box_center[1],50.0,1.0)
		
		#lightOnePosition = (40.0, 40, 100.0, 0.0)
		#lightOnePosition = (20.0, 20, 300.0, 1.0)
		
		#lightOnePosition =  (30000.0, 30000.0, 300.0, 500000000.0)
		lightOneColor = 20.0*array((1.0, 1.0, 1.0, 1.0) )
		#lightOneColor = (1000.9, 10000.9, 0.0, 1.0)
		
		#lightTwoPosition = (-40.0, 40, 100.0, 0.0)
		#lightTwoPosition=  (30000.0, 30000.0, -300.0, 500000000.0)
		lightTwoPosition = ( self.box_center[0],
				    self.box_center[1],1.0,1.0)
		
		lightTwoColor =15.0*array((1.0, 1.0, 1.0, 1.0))

		

		
		glLightfv (GL_LIGHT0, GL_POSITION, lightOnePosition)
		glLightfv (GL_LIGHT0, GL_DIFFUSE, lightOneColor)
		glLightfv (GL_LIGHT0, GL_SPECULAR, 100*lightOneColor)
		#glLightfv (GL_LIGHT0, GL_LINEAR_ATTENUATION,1.0)
                
		
		
		
	
		glLightfv (GL_LIGHT1, GL_POSITION, lightTwoPosition)
		glLightfv (GL_LIGHT1, GL_DIFFUSE, lightTwoColor)
		glLightfv (GL_LIGHT1, GL_SPECULAR, lightTwoColor)

		glEnable (GL_LIGHTING)
		
		glEnable (GL_LIGHT0)
		glEnable (GL_LIGHT1)

		glLightModelf(GL_LIGHT_MODEL_TWO_SIDE,0.0)

		
		#glPolygonMode	(	face, mode GL_POLYGON_SMOOTH )
		#glPolygonMode	( GL_FRONT, GL_POLYGON_SMOOTH )
		#glEnable	(GL_POLYGON_SMOOTH  )
		#print 'GL_POLYGON_SMOOTH:',glIsEnabled (GL_POLYGON_SMOOTH)
		# blending and alpha stuff
		#glEnable(GL_BLEND)

		# material

                mat = [0.1745, 0.01175, 0.01175, 1.0]
                glMaterialfv(GL_FRONT, GL_AMBIENT, mat)

                #mat[0] = 0.61424; mat[1] = 0.04136; mat[2] = 0.04136
                mat[0] = 1.5*0.61424; mat[1] = 1.5*0.04136; mat[2] =1.5*0.04136
                glMaterialfv(GL_FRONT, GL_DIFFUSE, mat)

                mat[0] =5.0*0.727811; mat[1] =5.0*0.626959; mat[2] =5.0*0.626959
                glMaterialfv(GL_FRONT, GL_SPECULAR, mat)
                glMaterialf(GL_FRONT, GL_SHININESS, 0.9*128.0)
                
		
		
		#glMaterialfv(GL_FRONT, GL_AMBIENT,
                #             0.0*array([1.0, 1.0, 1.0, 1.0]))


		#glMaterialfv(GL_FRONT, GL_DIFFUSE,
                #             0.0*array([1.0, 1.0, 1.0, 1.0]))

		#glMaterialfv(GL_FRONT, GL_SPECULAR,
                #             100.0*array([1.0, 1.0, 1.0, 1.0]))

		#glMaterialf(GL_FRONT, GL_SHININESS, 1.5*128.0)
		#glEnable(GL_MATERIAL)
                glEnable(GL_COLOR_MATERIAL)



		

		# enable array functions
		glVertexPointerd(self.vertex)
		glColorPointerd(self.color)
		glNormalPointerd(self.norm)

		glEnableClientState(GL_VERTEX_ARRAY)
		glEnableClientState(GL_COLOR_ARRAY)
		glEnableClientState(GL_NORMAL_ARRAY)	
		
		
		
		self.sim.append_obj_output(self)

    def make_user_arrays(self):
	    if self.show_users_flag:
		# add users arrays

    
		# man
		ind_old=len(self.vertex)
		#del points,faces,colors
		points,faces,colors=self.read_glfile(
			'objlib/base/user/test_driver.off',
			scale_x=0.3,scale_y=0.3,scale_z=0.4,
			offset_x=0.0,offset_y=0.0,offset_z=1.7)
	
		for ind in range(len(colors)):
			colors[ind]=self.color_users

		(vert,color,norm,
		 self.range_user)=self.get_trianglematices(
			points,faces,colors,0)

		
		
		# append matrices with segments to global matrix array
		self.vertex=concatenate((self.vertex,vert),axis=0)
		self.norm=concatenate((self.norm,norm),axis=0)
		self.color=concatenate((self.color,color),axis=0)
		
		self.range_user=arange(ind_old,len(self.vertex))


		# women
		ind_old=len(self.vertex)
		del points,faces,colors
		scale=0.05
		points,faces,colors=self.read_glfile(
			'objlib/base/user/debbie.off',
			scale_x=scale,scale_y=scale,scale_z=1.7*scale,
			preoffset_x=-16030,preoffset_y=-8260,preoffset_z=-94)

		for ind in range(len(colors)):
			colors[ind]=self.color_users

		(vert,color,norm,
		 self.range_user_fem)=self.get_trianglematices(
			points,faces,colors,0)

		
		
		# append matrices with segments to global matrix array
		self.vertex=concatenate((self.vertex,vert),axis=0)
		self.norm=concatenate((self.norm,norm),axis=0)
		self.color=concatenate((self.color,color),axis=0)
		
		self.range_user_fem=arange(ind_old,len(self.vertex))
		
	

    def read_glfile(self,filename,
                    scale_x=0.1,scale_y=0.1,scale_z=0.1,
                    offset_x=0.0,offset_y=0.0,offset_z=0.0,
		    preoffset_x=0.0,preoffset_y=0.0,preoffset_z=0.0):
        """
        Reads points,faces and colors from a text file with OpenGL data.
        """
        # load gl info from file
        file=open(filename,'r')
        data=file.readlines()
        file.close()
        key=''
		
        n=0
        #print 'len(data)',len(data)
        while (not key )&(n<len(data)):
            line=string.split(data[n],'#')[0]
            #print n,line
            if (string.find(line,'OFF')>=0)|\
			   (string.find(line,'off')>=0):
                key='off'
            n+=1
			
        if key=='off':
            n_points=0
            n_faces=0
            while (not n_faces) & (n<len(data)):
                line=string.split(data[n],'#')[0]
                #print key,n,line
                elem=string.split(line,' ')
                if len(elem)>2:
                    n_points=string.atoi(elem[0])
                    n_faces=string.atoi(elem[1])
                n+=1
            #print 'n_points=',n_points,'n_faces=',n_faces	

            # read points
            m=0
            points=[]
            while (m<n_points)&(n<len(data)):
                tup=get_list(data[n])
                if len(tup)>=3:
                    points.append(((tup[0]+preoffset_x)*scale_x+offset_x,
				   (tup[1]+preoffset_y)*scale_y+offset_y,
				   (tup[2]+preoffset_z)*scale_z+offset_z))
                    #print 'point',n,m,points[m],len(tup)
                    m+=1
                n=n+1

            # read faces
            m=0
            faces=[]
            colors=[]

            while (m<n_faces)&(n<len(data)):
                tup=get_list(data[n])
                lt=len(tup)
                #print 'Line',n,tup
                if lt>7:
					
                    # number of vertex
                    nv=int(tup[0])
                    li=[]
                    for n_tup in range(1,nv+1):
                        li.append(int(tup[n_tup]))
						
                    faces.append(li)
                    #print 'face',m,lt,nv
                    if nv+4<lt:
                        # alpha channel is given
                        colors.append(tup[nv+1:nv+5])
                    else:
                        # no alpha..make solid
                        colors.append(tup[nv+1:nv+5]+[1.0,])


                    #print 'face',m
                    #print '  face',faces[m]
                    #print '  color', colors[m]
                    m+=1
					
                n=n+1

        return points,faces,colors



    
    def get_trianglematices(self,points,faces,colors,do_average_normals=1):
        """
        Convert 3D data represented as points, faces and color information
        to array data suitable for the gl TRIANGLE generator.
        """
        if do_average_normals:
            # average normals in points
            normal_points=[]
            for nn in range(len(points)):
                normal_points.append([0,0,0])
            
			
            for m in range(len(faces)):
                face=faces[m]
                average_normal_points(face[0],face[1],face[2],
                                           points,normal_points)
            

                for n in range(3,len(face)):
                    average_normal_points(face[0],\
                                          face[n-1],\
                                          face[n],points,
                                          normal_points)
                

            # normalize average normals
            for nn in range(len(points)):
                [nx,ny,nz]=normal_points[nn]
                length=sqrt(nx**2+ny**2+nz**2)
                if length>0:
                    normal_points[nn]=[nx/length,ny/length,nz/length]
			
			
        # translate faces to triangle vertex
        vertex_triangles=[]
        color_triangles=[]
        normal_triangles=[]
		
        for m in range(len(faces)):
            face=faces[m]
            #print 'face=',face
            p1=points[face[0]]
            p2=points[face[1]]
            p3=points[face[2]]

			
            vertex_triangles.append(p1)
            vertex_triangles.append(p2)
            vertex_triangles.append(p3)

            if do_average_normals:
                normal_triangles.append(normal_points[face[0]])
                normal_triangles.append(normal_points[face[1]])
                normal_triangles.append(normal_points[face[2]])
            else:
                # add same normal for each point
                norm=get_normal(p1,p2,p3)
                normal_triangles.append(norm)
                normal_triangles.append(norm)
                normal_triangles.append(norm)
                
            
            color_triangles.append(colors[m])
            color_triangles.append(colors[m])
            color_triangles.append(colors[m])
            
            for n in range(3,len(face)):
                p1=points[face[0]]
                p2=points[face[n-1]]
                p3=points[face[n]]

                if do_average_normals:
                    normal_triangles.append(normal_points[face[1]])
                    normal_triangles.append(normal_points[face[n-1]])
                    normal_triangles.append(normal_points[face[n]])
                else:
                    # add same normal for each point
                    norm=get_normal(p1,p2,p3)
                    normal_triangles.append(norm)
                    normal_triangles.append(norm)
                    normal_triangles.append(norm)
                
                vertex_triangles.append(p1)
                vertex_triangles.append(p2)
                vertex_triangles.append(p3)
                
                
                color_triangles.append(colors[m])
                color_triangles.append(colors[m])
                color_triangles.append(colors[m])
				
        #vertex_triangles=array(vertex_triangles)
        #color_triangles=array(color_triangles)
        #normal_triangles=array(normal_triangles)
        #range_triangles=arange(0,len(vertex_triangles))

        return (array(vertex_triangles),\
                array(color_triangles),\
                array(normal_triangles),\
                arange(0,len(vertex_triangles)) )

    def get_quadmatices(self,points,faces,colors):
        """
        Convert 3D data represented as points, faces and color information
        to array data suitable for the gl QUAD generator.
        """
       		
			
        # translate faces to triangle vertex
        vert=[]
        color=[]
        norm=[]
		
        for m in range(len(faces)):
            face=faces[m]
            #print 'face=',face
            p1=points[face[0]]
            p2=points[face[1]]
            p3=points[face[2]]
            p4=points[face[3]]
			
            vert.append(p1)
            vert.append(p2)
            vert.append(p3)
            vert.append(p4)
            
            # add same normal for each point
            normm=get_normal(p1,p2,p4)
            norm.append(normm)
            norm.append(normm)
            norm.append(normm)
            norm.append(normm)
                
            
            color.append(colors[m])
            color.append(colors[m])
            color.append(colors[m])
            color.append(colors[m])
            
          
        return (array(vert),\
                array(color),\
                array(norm),\
                arange(0,len(vert)) )
    
    def add_vertex(self,vertex):
	    """
	    Appends a vertex to self.vertex
	    """
	    #print 'add_vertex'
	    #print vertex
	    #print self.vertex
	    self.vertex=concatenate((self.vertex,
				     array([vertex])),
				    axis=0)
	    
	    
    def add_normal(self,norm):
	    """
	    Appends a vertex to self.vertex
	    """
	    #print 'add_normal'
	    #print norm
	    #print self.norm
	    
	    self.norm=concatenate((self.norm,
				   array([norm])),
				  axis=0)
	    
	    
    def add_color(self,color):
	    """
	    Appends a vertex to self.vertex
	    """
	    self.color=concatenate((self.color,
				    array([color])),
				   axis=0)
	    

    def make_trackmatices_test(self,intersection):
        """
        Convert 2D intersection data of guideway + section information of
	netsim to array data suitable for the gl QUAD generator.
	The matrix data will be added to the already existing matrices
	self.vertex, self.color, self.norm and an index array
	self.range_track will be generated.
        """
	color_track=self.color_track
	ind_old=len(self.vertex)
	ind=ind_old
	
	vertex=array([[0.0, 5.0, 0.0],
		      [0.0, -5.0, 0.0],
		      [-5.0, -5.0, 0.0],
		      [-5.0, 5.0, 0.0],
		      [0.0, 5.0, 1.0],
		      [0.0, -5.0, 1.0],
		      [-5.0, -5.0, 1.0],
		      [-5.0, 5.0, 1.0],
		      ])

	norm=array([[0.0, 5.0, 0.0],
		    [0.0, -5.0, 0.0],
		    [-5.0, -5.0, 0.0],
		    [-5.0, 5.0, 0.0],
		    [0.0, 5.0, 1.0],
		    [0.0, -5.0, 1.0],
		    [-5.0, -5.0, 1.0],
		    [-5.0, 5.0, 1.0],
		    ])  

	color =array([[0.0, 1.0, 0.0, 0.0],
		      [0.0, 1.0, 0.0, 0.0],
		      [0.0, 1.0, 0.0, 0.0],
		      [1.0, 0.0, 0.0, 0.2],
		      [1.0, 0.0, 0.0, 0.2],
		      [1.0, 0.0, 0.0, 0.2],
		      [0.0, 1.0, 0.0, 0.0],
		      [0.0, 1.0, 0.0, 0.0],
		      ])
	
	self.vertex=concatenate((self.vertex,vertex),axis=0)
	self.norm=concatenate((self.norm,norm),axis=0)
	self.color=concatenate((self.color,color),axis=0)
	self.range_track=arange(ind_old,ind_old+8)

    def adjust_box(self,v):
	    """
	    Adjust box boundaries witz vector v which is in the box.
	    """
	    ind=nonzero(v>self.box_max)
	    put(self.box_max,ind,take(v,ind))

	    ind=nonzero(v<self.box_min)
	    put(self.box_min,ind,take(v,ind))

	    self.box_center=(self.box_max+self.box_min)/2.0

    def append_quadmatrices(self,points,faces,colors,trr,offset):
        """
        Transforms and append points, faces and colors data to GL matrices.
        Offset is added to points BEFORE translation.
        """
        tpoints=copy.copy(points)
        for n in range(len(points)):
                point=points[n]
                #print transpose(matrixmultiply(trans,
                #                     [[point[1]],[point[0]],[point[2]],[1.0]]
                #                        )[0:3,0])
                tpoints[n]=transpose(matrixmultiply(trr,
                                     [[point[1]+offset[1]],
                                      [point[0]+offset[0]],
                                      [point[2]+offset[2]],[1.0]]
                                        )[0:3,0]).tolist()
                
        (vert,color,norm,inds)=self.get_quadmatices(\
                tpoints,faces,colors)

        # append matrices with segments to global matrix array
        self.vertex=concatenate((self.vertex,vert),axis=0)
        self.norm=concatenate((self.norm,norm),axis=0)
        self.color=concatenate((self.color,color),axis=0)


    #def make_users(self,intersection):
    #    """
    #Create triangle-matrics for users.
    #    """
	

    def make_poles(self,color_track):
        """
        Generate matrices for all poles
        """

        # place poles
	for sec in self.netsim.secs.values():
		#print '------------sec',sec.id,sec.length

		# put poles at defined distances
		pp=arange(0,sec.length,self.dist_poles)
		if len(pp)>1:
			#self.make_pole(sec.segs[0],0.0,color_track)
			n=0
			l=0.0
			lseg=0.0
			
			for p in pp[1:]:
				while p>l:
					lseg=sqrt(sum(power(
						sec.segs[n+1][0:3,3]-\
						sec.segs[n][0:3,3],2)))
					l+=lseg
					n+=1
				trans=sec.segs[n-1]
				#print 'make_pole at p=',p,n-1,p-(l-lseg)
				self.make_pole(trans,p-(l-lseg),color_track)
    
    def make_trackmatices(self,intersection):
        """
        Convert 2D intersection data of guideway + section information of
	netsim to array data suitable for the gl QUAD generator.
	The matrix data will be added to the already existing matrices
	self.vertex, self.color, self.norm and an index array
	self.range_track will be generated.
        """
	print '3D monitor: make_trackmatices...'
	
	color_track=self.color_track
	ind_old=len(self.vertex)


        # place poles
	if self.make_pole:
		self.make_poles(color_track)

	# make stations
        points_struct,faces_struct,colors_struct=self.read_glfile(
			'objlib/test/track/stop_schelter_struct.off',
			-0.02,0.02,0.02, 
                        0.0,0.0,0.0)
        
        points_roof,faces_roof,colors_roof=self.read_glfile(
			'objlib/test/track/stop_schelter_roof.off',
			-0.02,0.02,0.02, 
                        0.0,0.0,0.0)
        
        points_plat,faces_plat,colors_plat=self.read_glfile(
			'objlib/test/track/stop_platform.off',
			-0.02,0.02,0.02, 
                        0.0,0.0,0.0)

        points_elev,faces_elev,colors_elev=self.read_glfile(
			'objlib/test/track/stop_elevator.off',
			-0.02,0.02,0.02, 
                        0.0,0.0,0.0)

        points_structr,faces_struct,colors_struct=self.read_glfile(
			'objlib/test/track/stop_schelter_struct.off',
			0.02,0.02,0.02, 
                        0.0,0.0,0.0)
        
        points_roofr,faces_roof,colors_roof=self.read_glfile(
			'objlib/test/track/stop_schelter_roof.off',
			0.02,0.02,0.02, 
                        0.0,0.0,0.0)
        
        points_platr,faces_plat,colors_plat=self.read_glfile(
			'objlib/test/track/stop_platform.off',
			0.02,0.02,0.02, 
                        0.0,0.0,0.0)

        points_elevr,faces_elev,colors_elev=self.read_glfile(
			'objlib/test/track/stop_elevator.off',
			0.02,0.02,0.02, 
                        0.0,0.0,0.0)
        
        #print 'faces_plat',faces_plat
        #print 'points_plat',points_plat
        #print 'colors_plat',colors_plat
        length_roof=5.0
        width_platform=2.7

        for stop in self.sim.get_stops().values():
            tr=copy.copy(stop.berthssec.segs[0])
            #tr[0:3,3]=tr[0:3,3]+array([0.0,-1.5*stop.side,0.0])
            #tr[0:3,3]=tr[0:3,3]+array([0.0,-1.5,0.0])
            print stop.id,' side=',stop.side
            # add shelter
            if stop.side==1:
                for pos in range(0.0,stop.berthssec.length,length_roof):
                
                    # beam structure
                    self.append_quadmatrices(points_struct,faces_struct,colors_struct,
                                         tr,array([0.0,pos,0.0]))
                    # roof
                    self.append_quadmatrices(points_roof,faces_roof,colors_roof,
                                         tr,array([0.0,pos,0.0]))

                    # add platform
                    self.append_quadmatrices(points_plat,faces_plat,colors_plat,
                                         tr,array([0.0,pos+length_roof,0.0]))
                # last beam structure 
                self.append_quadmatrices(points_struct,faces_struct,colors_struct,
                                         tr,array([0.0,stop.berthssec.length,0.0]))
            
                # and elevator
                self.append_quadmatrices(points_elev,faces_elev,colors_elev,
                                         tr,array([-1.90,-2.0,0.0]))
            else:
                for pos in range(0.0,stop.berthssec.length,length_roof):
                
                    # beam structure
                    self.append_quadmatrices(points_structr,faces_struct,colors_struct,
                                         tr,array([0.0,pos,0.0]))
                    # roof
                    self.append_quadmatrices(points_roofr,faces_roof,colors_roof,
                                         tr,array([0.0,pos,0.0]))

                    # add platform
                    self.append_quadmatrices(points_platr,faces_plat,colors_plat,
                                         tr,array([0.0,pos+length_roof,0.0]))
                # last beam structure 
                self.append_quadmatrices(points_structr,faces_struct,colors_struct,
                                         tr,array([0.0,stop.berthssec.length,0.0]))
            
                # and elevator
                self.append_quadmatrices(points_elevr,faces_elev,colors_elev,
                                         tr,array([+1.90,-2.0,0.0]))
            
 
	
        # determine size of array-matrices for track only
        len_sec=len(self.netsim.secs.values())
        len_seg_inter=len(intersection)
        len_segs=len(self.netsim.segs.arrays)
        len_array=(len_segs-len_sec)*len_seg_inter*4
        
        vert=0.0*ones((len_array,3))
        norm=0.0*ones((len_array,3))
        
        color=array(color_track)*(1.0*ones((len_array,4)))
        #print 'len_array',len_array
        
        n=0
        n_sec=0
        n_segs=0
        
        for sec in  self.netsim.secs.values():
                len_seg=len(sec.segs)
                n_sec+=1
                n_segs+=len_seg
		#print '------------sec',sec.id,sec.length
		#print 'len_sec,n_sec',len_sec,n_sec
		#print 'len_seg,len_segs,n_segs',len_seg,len_segs,n_segs
		# put guiderway with defined intersection
		for n_inter in range(-1,len_seg_inter-1):
                        #print 'iiii',n_inter
			vx0,vz0=intersection[n_inter]
			vx1,vz1=intersection[n_inter+1]
			v_inter0=array([[0.0],[vx0],[vz0],[1.0]])
			v_inter1=array([[0.0],[vx1],[vz1],[1.0]])
			
			for n_seg in range(0,len_seg-1):
                                #print 'sssssed',n_seg
				trans0=sec.segs[n_seg]
				trans1=sec.segs[n_seg+1]

				vq1=matrixmultiply(
					trans0,v_inter0)[0:3,0]
				vq2=matrixmultiply(
					trans0,v_inter1)[0:3,0]
				vq3=matrixmultiply(
					trans1,v_inter1)[0:3,0]
				vq4=matrixmultiply(
					trans1,v_inter0)[0:3,0]

                                
                                #print 'n_seg,len_array,n',n_seg,len_array,n
				
                                #put(vertex,range(n,n+4))
                                
				vert[n:n+4,:]=array([vq1,vq2,vq3,vq4])
                                #put(vertex,n,vq1)
                                #vertex[n]=vq1
                                #vertex[n+1]=vq2
                                #vertex[n+2]=vq3
                                #vertex[n+3]=vq4
                                
                                #print 'array',array([vq1,vq2,vq3,vq4])
				#print 'vert',vert[n:n+4,:]
				#print 'vert[0:20]',vert[0:20]
				
				
				norm[n:n+4,:]=array(get_normal(vq1,vq2,vq4))
				#self.add_quad(vq1,vq2,vq3,vq4,
				#	      color_track)
				n+=4

        #for v in vertex:
        #    print 'v=',v
        #print '======================================'
        #print 'vert[0:20]',vert[0:20]
        #print 'self.vertex',self.vertex[ind_old:ind_old+20]    

        # append matrices with segments to global matrix array
        self.vertex=concatenate((self.vertex,vert),axis=0)
        self.norm=concatenate((self.norm,norm),axis=0)
        self.color=concatenate((self.color,color),axis=0)
        
	
            
	
	

		

	vmin=self.box_center[0:2]+10.0*(self.box_min[0:2]-self.box_center[0:2])
	vmax=self.box_center[0:2]+10.0*(self.box_max[0:2]-self.box_center[0:2])

        #print 'self.box_min=',self.box_min
	#print 'self.box_max=',self.box_max
	#print 'vmin=',vmin
	#print 'vmax=',vmax
	self.box_track_min=self.box_min.copy()
	self.box_track_max=self.box_max.copy()
	
	vq1=array([vmin[0],vmin[1],self.box_min[2]])
        vq2=array([vmin[0],vmax[1],self.box_min[2]])
	vq3=array([vmax[0],vmax[1],self.box_min[2]])
	vq4=array([vmax[0],vmin[1],self.box_min[2]])
	
	self.add_quad(vq1,vq2,vq3,vq4,self.color_ground) 
	# generate vertex index list for track
	#print '  range_track=',ind_old,ind
	
	self.range_track=arange(ind_old,len(self.vertex))

        # add grid
        ind_old=len(self.vertex)
        z=self.box_min[2]+0.1

        y_min=self.box_track_min[1]
        y_max=self.box_track_max[1]

        x_min=self.box_track_min[0]
        x_max=self.box_track_max[0]

        #print 'grid x=',x_min,x_max
        #print 'grid y=',y_min,y_max

        
        for x in range(int(x_min),int(x_max),self.width_grid):
            #print 'grid x=',x,y_min,y_max
            self.add_line([x,y_min,z],[x,y_max,z],[0.0,0.0,1.0],self.color_grid)
            
        for y in range(int(y_min),int(y_max),self.width_grid):
            #print 'grid y=',y,x_min,x_max
            self.add_line([x_min,y,z],[x_max,y,z],[0.0,0.0,1.0],self.color_grid)
            
        self.range_grid=arange(ind_old,len(self.vertex))
        
	#for n_vert in range(len(self.vertex)):
	#	if n_vert<ind_old:
	#		print '  car vertex no',n_vert,'=',self.vertex[n_vert]
	#	else:
	#		print '  track vertex no',n_vert,'=',self.vertex[n_vert]
    #def arcfunc(self,x,x0,z0,z1):
#	    """
#	    Function of an arc, used to create the poles.
#	    """
#	    return z1-(z1-z0)/x0**4*x
	    
    #def make_pole(self,trans,d_segp,color):
#	    """
#	    Make a pole at the given transform matrix.
#	    """
#	    pass

    
        
    def make_portici(self,trans,d_seg,color):
	    """
	    Make a pole at the given transform matrix.
	    """
            # put left and right pillar
            
            y_offset_pole=-1.6
            r_pole=0.2
            
            n_sides_pole=6

            z_offset_arc=-0.5
            d_arc=2.0*r_pole
            n_segs_arc=8
            r_arc=abs(y_offset_pole)-r_pole
            z_offset_pole=z_offset_arc-r_arc-d_arc
            len_pole=5.3-r_arc-d_arc
            
            
            
            self.make_pole_round(trans,d_seg,color,
                                 y_offset=y_offset_pole,z_offset=-z_offset_pole,
                                 len_pole=len_pole,r=r_pole,
                                 n_sides=n_sides_pole)
            
            self.make_pole_round(trans,d_seg,color,
                                 y_offset=-y_offset_pole,z_offset=-z_offset_pole,
                                 len_pole=len_pole,r=r_pole,
                                 n_sides=n_sides_pole)
            
            
	    #make arc
	    
	    phi=arange(pi+pi/n_segs_arc,-2.0*pi/n_segs_arc,-pi/n_segs_arc)
	    x=r_arc*cos(phi)
	    z=z_offset_arc-r_arc+r_arc*sin(phi)-d_arc
            x[0]=-r_arc-d_arc
            z[0]=z_offset_arc-r_arc-d_arc
            x[-1]=+r_arc+d_arc
            z[-1]=z_offset_arc-r_arc-d_arc
            
            nx=len(x)
            df=d_seg-d_arc/2.0
            db=d_seg+d_arc/2.0
            
            # top cover
            vf1=matrixmultiply(\
			 trans,
		         array([[df],[x[0]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf2=matrixmultiply(\
			  trans,
		        array([[df],[x[-1]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf3=matrixmultiply(\
		        trans,
			  array([[db],[x[-1]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf4=matrixmultiply(\
                    trans,    
                    array([[db],[x[0]],[z_offset_arc],[1.0]])
                     )[0:3,0]
		    
	    self.add_quad(vf4,vf3,vf2,vf1,color)

	    # left cover
            vf1=matrixmultiply(\
			 trans,
		         array([[df],[x[0]],[z[0]],[1.0]])
			 )[0:3,0]
	    vf2=matrixmultiply(\
			  trans,
		        array([[df],[x[0]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf3=matrixmultiply(\
		        trans,
			  array([[db],[x[0]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf4=matrixmultiply(\
                    trans,    
                    array([[db],[x[0]],[z[0]],[1.0]])
                     )[0:3,0]
		    
	    self.add_quad(vf4,vf3,vf2,vf1,color)

	    # right cover
            vf4=matrixmultiply(\
			 trans,
		         array([[df],[x[-1]],[z[-1]],[1.0]])
			 )[0:3,0]
	    vf3=matrixmultiply(\
			  trans,
		        array([[df],[x[-1]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf2=matrixmultiply(\
		        trans,
			  array([[db],[x[-1]],[z_offset_arc],[1.0]])
			 )[0:3,0]
	    vf1=matrixmultiply(\
                    trans,    
                    array([[db],[x[-1]],[z[-1]],[1.0]])
                     )[0:3,0]
		    
	    self.add_quad(vf4,vf3,vf2,vf1,color)

	    

	    
		    
            # do arc
	    for n in range(0,nx-1):
		    #front-side
                    
		    vf1=matrixmultiply(\
			    trans,
			    array([[df],[x[n]],[z[n]],[1.0]])
			    )[0:3,0]
		    vf2=matrixmultiply(\
			    trans,
			    array([[df],[x[n+1]],[z[n+1]],[1.0]])
			    )[0:3,0]
		    vf3=matrixmultiply(\
			    trans,
			    array([[df],[x[n+1]],[z_offset_arc],[1.0]])
			    )[0:3,0]
		    vf4=matrixmultiply(\
			    trans,
			    array([[df],[x[n]],[z_offset_arc],[1.0]])
			    )[0:3,0]
		    
		    
		    self.add_quad(vf4,vf3,vf2,vf1,color)

		    #back-side
		    
		    vb4=matrixmultiply(\
			    trans,
			    array([[db],[x[n]],[z[n]],[1.0]])
			    )[0:3,0]
		    vb3=matrixmultiply(\
			    trans,
			    array([[db],[x[n+1]],[z[n+1]],[1.0]])
			    )[0:3,0]
		    vb2=matrixmultiply(\
			    trans,
			    array([[db],[x[n+1]],[z_offset_arc],[1.0]])
			    )[0:3,0]
		    vb1=matrixmultiply(\
			    trans,
			    array([[db],[x[n]],[z_offset_arc],[1.0]])
			    )[0:3,0]
		    self.add_quad(vb4,vb3,vb2,vb1,color)

		    #inner-side
		    db=d_seg+d_arc/2.0
		    vs4=matrixmultiply(\
			    trans,
			    array([[df],[x[n]],[z[n]],[1.0]])
			    )[0:3,0]
		    vs3=matrixmultiply(\
			    trans,
			    array([[df],[x[n+1]],[z[n+1]],[1.0]])
			    )[0:3,0]
		    vs2=matrixmultiply(\
			    trans,
			    array([[db],[x[n+1]],[z[n+1]],[1.0]])
			    )[0:3,0]
		    vs1=matrixmultiply(\
			    trans,
			    array([[db],[x[n]],[z[n]],[1.0]])
			    )[0:3,0]
		    self.add_quad(vs4,vs3,vs2,vs1,color)

		
	 

    def make_pole_round(self,trans,d_seg,color,
                        y_offset=0.0,z_offset=0.52,len_pole=5.3,r=0.3,n_sides=6):
	    """
	    Make a pole at the given transform matrix.
	    """
	    
	    phi=arange(0.0,2.0*pi-2.0*pi/n_sides,2.0*pi/n_sides)
	    
	    
	    
	    x_circ=r*cos(phi) 
	    y_circ=r*sin(phi)

	    for n in range(len(phi)):
                    v1=matrixmultiply(\
			    trans,
			    array([[d_seg+x_circ[n-1]],
                                   [y_offset+y_circ[n-1]],
                                   [-z_offset],
                                   [1.0]])
			    )[0:3,0]
                    v2=matrixmultiply(\
			    trans,
			    array([[d_seg+x_circ[n-1]],
                                   [y_offset+y_circ[n-1]],
                                   [-len_pole-z_offset],
                                   [1.0]])
			    )[0:3,0]

                    v3=matrixmultiply(\
			    trans,
			    array([[d_seg+x_circ[n]],
                                   [y_offset+y_circ[n]],
                                   [-len_pole-z_offset],
                                   [1.0]])
			    )[0:3,0]

                    v4=matrixmultiply(\
			    trans,
			    array([[d_seg+x_circ[n]],
                                   [y_offset+y_circ[n]],
                                   [-z_offset],
                                   [1.0]])
			    )[0:3,0]
		    
		    #print phi[n]*180/pi,v1,v2,v3,v4
		    
		    self.add_quad(v1,v2,v3,v4,color)

		    
    def make_pole_arc(self,trans,d_segp,color):
	    """
	    Make a pole at the given transform matrix.
	    """
	    d_seg=d_segp
	    #print 'make_pole'
	    x0e=1.8
	    x0i=1.6
	    z1e=0.5
	    z1i=-0.8
	    z0=-5.3
	    xd=0.2
	    yd=0.2

	    x=arange(-x0e,x0e+xd,xd)
	    
	    ze=clip(z1e-(z1e-z0)/x0e**4*x**4,z0,-0.6)
	    zi=clip(z1i-(z1i-z0)/x0i**4*x**4,z0,-0.6)

            self.make_arc(trans,d_segp,color,x,yd,ze,zi)
	    #print 'x=',x
	    #print 'ze=',ze
	    #print 'zi=',zi

    def make_arc(self,trans,d_seg,color,x,yd,ze,zi):
            nx=len(x)
	    # left extremity
	    #front-side
	    vf1=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[0]],[ze[0]],[1.0]])
			    )[0:3,0]
	    vf2=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[1]],[zi[1]],[1.0]])
			    )[0:3,0]
	    vf3=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[2]],[zi[2]],[1.0]])
			    )[0:3,0]
	    vf4=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[1]],[ze[1]],[1.0]])
			    )[0:3,0]
	    #back-side
	    vb4=matrixmultiply(\
			    trans,
			    array([ [d_seg-yd],[x[0]],[ze[0]],[1.0] ])
			    )[0:3,0]
	    vb3=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[1]],[zi[1]],[1.0]])
			    )[0:3,0]
	    vb2=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[2]],[zi[2]],[1.0]])
			    )[0:3,0]
	    vb1=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[1]],[ze[1]],[1.0]])
			    )[0:3,0]
	    
	    self.add_cube(vf1,vf2,vf3,vf4,vb1,vb2,vb3,vb4,color)

	    # right extremity
	    #front-side
	    vf1=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[nx-2]],[ze[nx-2]],[1.0]])
			    )[0:3,0]
	    vf2=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[nx-3]],[zi[nx-3]],[1.0]])
			    )[0:3,0]
	    vf3=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[nx-2]],[zi[nx-2]],[1.0]])
			    )[0:3,0]
	    vf4=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[nx-1]],[ze[nx-1]],[1.0]])
			    )[0:3,0]
	    #back-side
	    vb4=matrixmultiply(\
			    trans,
			    array([ [d_seg-yd],[x[nx-2]],[ze[nx-2]],[1.0] ])
			    )[0:3,0]
	    vb3=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[nx-3]],[zi[nx-3]],[1.0]])
			    )[0:3,0]
	    vb2=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[nx-2]],[zi[nx-2]],[1.0]])
			    )[0:3,0]
	    vb1=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[nx-1]],[ze[nx-1]],[1.0]])
			    )[0:3,0]
	    
	    self.add_cube(vf1,vf2,vf3,vf4,vb1,vb2,vb3,vb4,color)
		    
	   
	    # do arc
	    for n in range(1,nx-2):
		    #front-side
		    vf1=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[n]],[ze[n]],[1.0]])
			    )[0:3,0]
		    vf2=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[n]],[zi[n]],[1.0]])
			    )[0:3,0]
		    vf3=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[n+1]],[zi[n+1]],[1.0]])
			    )[0:3,0]
		    vf4=matrixmultiply(\
			    trans,
			    array([[d_seg],[x[n+1]],[ze[n+1]],[1.0]])
			    )[0:3,0]
		    
		    
		    
		    #back-side
		    vb4=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[n]],[ze[n]],[1.0]])
			    )[0:3,0]
		    vb3=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[n]],[zi[n]],[1.0]])
			    )[0:3,0]
		    vb2=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[n+1]],[zi[n+1]],[1.0]])
			    )[0:3,0]
		    vb1=matrixmultiply(\
			    trans,
			    array([[d_seg-yd],[x[n+1]],[ze[n+1]],[1.0]])
			    )[0:3,0]
		    
		    self.add_cube(vf1,vf2,vf3,vf4,vb1,vb2,vb3,vb4,color)


		    
    def add_cube(self,vf1,vf2,vf3,vf4,vb1,vb2,vb3,vb4,color):
	    self.add_quad(vf1,vf2,vf3,vf4,color)
	    self.add_quad(vb1,vb2,vb3,vb4,color)
	    self.add_quad(vb1,vb4,vf1,vf4,color)
	    self.add_quad(vf3,vf2,vb3,vb2,color)





    def add_line(self,v1,v2,norm,color):
        """
        Add line to array matrix
        """

        #self.vertex[self.ind_array:self.ind_array+2]=array([v1,v2,])
        
        self.vertex=concatenate((self.vertex,
                                    array([v1,v2,])),
				    axis=0)
        
        self.norm=concatenate((self.norm,
				array([norm,norm,])),
				axis=0)
        
        self.color=concatenate((self.color,
				array([color,color])),
				axis=0)
        
        

	    
    def add_quad(self,vq1,vq2,vq3,vq4,color):
	    """
	    Adds a quadrillion to the GL array.
	    """
	    if has_normal(vq1,vq2,vq4):
		    self.vertex=concatenate((self.vertex,
					     array([vq1,vq2,vq3,vq4,])),
					    axis=0)
	    
		    norm=get_normal(vq1,vq2,vq4)
		    self.norm=concatenate((self.norm,
					   array([norm,norm,norm,norm])),
					  axis=0)

		    self.color=concatenate((self.color,
					    array([color,color,color,color])),
					   axis=0)
		    # adjust boundary box
		    self.adjust_box(vq1)
		    self.adjust_box(vq2)
		    self.adjust_box(vq3)
		    self.adjust_box(vq4)
	    
    def on_motion(self, x, y):
	    self.alpha_y+=self.alpha_step*sign(y-self.y_mouse)
	    if self.alpha_y<-90.0:
		     self.alpha_y=-90.0
	    elif self.alpha_y>90.0:
		    self.alpha_y=90.0
		    
	    self.alpha_z+=self.alpha_step*sign(x-self.x_mouse)
	    #if self.alpha_z>100.0:
	    #self.alpha_z=100.0
	    #elif self.alpha_z<0.0:
	    #	    self.alpha_z=0.0
	    lpos=((self.x_mouse,self.y_mouse , 300.0, 1.0))
	    glLightfv (GL_LIGHT0, GL_POSITION,lpos)
	    #print 'lightpos=',lpos
	    
	    
	    # store the mouse coordinate
	    self.x_mouse  = x
	    self.y_mouse = y
	    # redisplay
	    glutPostRedisplay()

    def on_reshape(self, width, height):
        # setup the viewport
        glViewport(0, 0, width, height)
        # setup the projection matrix
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        # calculate left/right and top/bottom clipping planes based
        #the smallest square viewport
        a = 9.0/min(width, height)
        clipping_planes = (a*width, a*height)

        # setup the projection
	# good close-up
        #glFrustum(-clipping_planes[0], clipping_planes[0], -clipping_planes[1],
        #          clipping_planes[1], 30.0, 150000.0)

	glFrustum(-clipping_planes[0], clipping_planes[0], -clipping_planes[1],
                  clipping_planes[1], 10.0, 150000.0)
	

    def loop_gl(self,arg=0):
	    #print 'loop_gl',arg,self.sim.sim_flag,self.sim.time
	    if self.sim.sim_flag:
		    self.sim.maincycle()
		    
    def on_display(self):
        
        # compute translation matrices for cars
        if self.netsim.cars.db:
            self.cartrans=self.netsim.segs.take(
                self.netsim.segs_ind.arrays+\
                (self.netsim.path_sec/self.netsim.length.arrays *
                 self.netsim.segs_total.arrays).astype(Int)
                )
            
            #print 'cartrans=',self.cartrans
	    self.offset=self.cartrans[:,0:2,3]
	    #print 'offset=',self.offset

	    self.mult=self.cartrans[:,0:2,0]
	    #print 'mult=',self.mult
	    self.path_seg=reshape(self.netsim.path_sec %\
                           self.netsim.seg_length.arrays,(len(self.mult),1))

            #print 'path_seg=',self.path_seg
	    #print 'coords=',self.offset+self.mult*self.path_seg

            #print 'on_display=================================='
	    
	    self.cartrans[:,3,0:2]=self.offset+self.mult*self.path_seg
	    self.cartrans[:,0:2,3]=0


	# clear the buffer
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
        
        # Set up the model view matrix
        glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	
	#glRotatef(120, 0.0, 1.0, 0.0)
	#glScalef(0.1,0.1,0.1)
	#glScalef(1.0,1.0,1.0)
	#glScalef(100.0,100.0,100.0)

	# good close-up
	#glScalef(50.0,50.0,50.0)

	glScalef(40.0,40.0,40.0)
	
	if self.view in('user','bici'):
		trans=self.cartrans[0]
		glRotatef(90,0.0, 1.0, 0.0)
		glRotatef(-90,1.0, 0.0, 0.0)
		alpha_z_user_current=-arctan2(
			trans[1,0],trans[0,0])*57.295779513082323
		if abs(alpha_z_user_current-self.alpha_z_user_lastcurrent)\
		   >350:
			self.alpha_z_user+=sign(alpha_z_user_current)*360.0
			#if alpha_z_user_current<0.0:
			#	self.alpha_z_user-=360.0
			#else:
				
		self.alpha_z_user=self.lambda_user*self.alpha_z_user\
				   +(1.0-self.lambda_user)*alpha_z_user_current
		#print self.alpha_z_user,alpha_z_user_current
		
		glRotatef(self.alpha_z_user,0.0, 0.0, 1.0)
		glTranslatef(-trans[3,0],-trans[3,1] , -trans[3,2]-self.z_user)

		self.alpha_z_user_lastcurrent=alpha_z_user_current
		#glMultMatrixf(1/self.cartrans[0])
		#glTranslatef(self.x, self.y,self.z)
	else:
		
		#glTranslatef(0.0, 0.0, -300.0)
		
		#lightTwoPosition = (self.alpha_y,self.alpha_z , 0.0, 1.0)
		#glDisable (GL_LIGHT1)
		#glLightfv (GL_LIGHT1, GL_POSITION, lightTwoPosition)
		#glEnable (GL_LIGHT1)

		glTranslatef(self.x, self.y,self.z)
		
		#glRotatef(-45.0, 1.0, 0.0, 0.0)
		#glRotatef(45.0, 0.0, 0.0, 1.0)
		glRotatef(self.alpha_y, 1.0, 0.0, 0.0)
		glRotatef(self.alpha_z, 0.0, 0.0, 1.0)
		#glRotatef(self.alpha_z, 0.0, 1.0, 0.0)
		#glRotatef(self.alpha_y, 1.0, 0.0, 0.0)
		
		
	#glRotatef(self.lastx, 0.0, 0.0, 1.0)
        #glRotatef(self.lasty, 1.0, 0.0, 0.0)
	
        #glMatrixMode(GL_PROJECTION)
        #glLoadIdentity()
        #glScalef(0.2,0.2,0.2)
        #glTranslatef(0.0, -50.0, -300.0)
        #glRotatef(self.lastx, 0.0, 1.0, 0.0)
        #glRotatef(self.lasty, 1.0, 0.0, 0.0)
	
	if self.netsim.cars.db:
            map(self.display_car,self.cartrans)

        # display track
	glDrawElementsui(GL_QUADS,self.range_track)
	glDrawElementsui(GL_LINES,self.range_grid)

	if self.show_users_flag:
		# display users
		self.display_users()
	
        glutSwapBuffers()
                
    def display_users(self):
	"""
        display_users
        """
	if (len(self.users.mods)>0):
		n_half=len(self.users.mods)
		n=0
		for user in self.users.mods.values():
			n+=1
			if user.car==None:
				glPushMatrix()
				# from user.get_position()
				#x,y)=self.users.position[user.no][0]
				(x,y)=user.get_position()
				glTranslatef(x,y ,0)

				if self.users.position.db.has_key(user.no):
					glRotatef(arctan2(
						self.users.step[user.no][0,0],
						self.users.step[user.no][0,1])\
						  *57.295779513082323-90-45,
						  0.0, 0.0, 1.0)
				if remainder(n,2)==0:
					glDrawElementsui(\
					     GL_TRIANGLES,self.range_user)
				else:
					glDrawElementsui(\
					     GL_TRIANGLES,self.range_user_fem)
			
				glPopMatrix()
				
    def display_car(self,trans):
        """
        Display carrier with transformation matrix trans
        """
        glPushMatrix()
	#print 'display_car',trans[3,0],trans[3,1] , trans[3,2]
	glTranslatef(trans[3,0],trans[3,1] , trans[3,2])
	glRotatef(arctan2(trans[1,0],trans[0,0])*57.295779513082323+90,
		  0.0, 0.0, 1.0)
        #teapotvehicles
        #glColor3f(0.9, 0.0, 0.0)
	#glRotatef(-90.0,0.0, 1.0, 0.0)
	#glRotatef(-90.0,0.0, 0.0, 1.0)
	#glTranslatef(0.0,0.8 , 0.0)
        #glutSolidTeapot(1.0)

	# real vehicles
        glDrawElementsui(GL_TRIANGLES,self.range_car)

        glPopMatrix()

    def on_key_pressed(self,*args):
	    """
	    The function called whenever a key is pressed.
	    Note the use of Python tuples to pass in: (key, x, y)
	    """
	    # If escape is pressed, kill everything.
	    #print 'on_key_pressed',args

	    inc=self.step
	    key,x,y=args
	    if key =='\033':# '\r': #'\033':
		    sys.exit()
	    elif key =='6':
		    self.x-=inc
	    elif key =='4':
		    self.x+=inc
	    elif key =='8':
		    self.y-=inc
	    elif key =='2':
		    self.y+=inc
	    elif key =='3':
		    self.z-=inc
	    elif key =='9':
		    self.z+=inc
	    elif key =='u':
		    self.alpha_z_user=self.alpha_z
		    self.z_user=1.5
		    self.view='user'
	    elif key =='b':
		    self.alpha_z_user=self.alpha_z
		    self.z_user=-4.0
		    self.view='bici'
	    elif key =='r':
		    self.view=''
	    elif key =='c':
		    self.sim.prepare_continue()
	    elif key =='s':
                    self.sim.stop()
                
		    
	    # redisplay
	    glutPostRedisplay()
		    
	    
    def output(self):
        # move all carriers in netsim
        #if self.netsim.cars.db:
	self.on_display()
        
            # compute nose and tail positions based on Netsim's
            # offset and xy multipliers
            #self.pos=concatenate((self.offset+self.mult*self.path_seg,
            #                      self.offset+self.mult*
            #                      (self.path_seg-self.car_length_netmon),
            #                      self.car_inds
            #                      ),(1)).tolist()
            #map(self.move_car,self.pos)
                
            
    #def move_car(self,pos):
    #    x_tail,y_tail,x_nose,y_nose,car_ind=pos
    #    self.canvas.coords(self.car_ids[int(car_ind)],
    #                       x_tail,y_tail,x_nose,y_nose)

            

    def plot_track(self):
        for id in self.sim.objs.keys():
            id_data=self.sim.split_id(id)
            if (id_data['category']=='track'):
                for elem in self.sim.objs[id].mods.values():
                    elem.plot()
                    
    def move(self,what_to_where,noscale=0):
        if noscale:
            for id,x_from, x_to,y_from, y_to in what_to_where:
                self.canvas.move(id, x_to-x_from , y_to-y_from)
        else:    
            s=self.canvas_scale           
            for id,x_from, x_to,y_from, y_to in what_to_where:
                self.canvas.move(id,(x_to-x_from)*s,(y_to-y_from)*s)
            
        self.adjust_area(id)


###############################################################################
# helper functions

def has_normal(p1,p2,p3):
	[a1,a2,a3]=[p2[0]-p1[0],p2[1]-p1[1],p2[2]-p1[2]]
	[b1,b2,b3]=[p3[0]-p1[0],p3[1]-p1[1],p3[2]-p1[2]]

	[dx,dy,dz]=[a2*b3-a3*b2, a3*b1-a1*b3, a1*b2-a2*b1]

	length=sqrt(dx**2+dy**2+dz**2)
	
	return length>10**-8

def get_normal(p1,p2,p3):

	
	[a1,a2,a3]=[p2[0]-p1[0],p2[1]-p1[1],p2[2]-p1[2]]
	[b1,b2,b3]=[p3[0]-p1[0],p3[1]-p1[1],p3[2]-p1[2]]

	[dx,dy,dz]=[a2*b3-a3*b2, a3*b1-a1*b3, a1*b2-a2*b1]

	length=sqrt(dx**2+dy**2+dz**2)
	if length>10**-10:
		return [dx/length,dy/length,dz/length]
	else:
		return [dx,dy,dz]

def get_normal_det(p1,p2,p3):
	[xu,yu,zu]=[p2[0]-p1[0],p2[1]-p1[1],p2[2]-p1[2]]
	[xv,yv,zv]=[p3[0]-p1[0],p3[1]-p1[1],p3[2]-p1[2]]

	[dx,dy,dz]=[determinant(array([[yu, yv],[zu,zv]])),
		    determinant(array([[xu, xv],[zu,zv]])),
		    determinant(array([[xu, xv],[yu,yv]]))]

	length=sqrt(dx**2+dy**2+dz**2)
	#if length<10.0**-8:
	#	length=1.0
	
	return [dx/length,-dy/length,dz/length]

def average_normal_points(ind_p1,ind_p2,ind_p3,points,normal_points):
		normal=get_normal(points[ind_p1],points[ind_p2],points[ind_p3])
		
		normal_points[ind_p1][0]+=normal[0]
		normal_points[ind_p1][1]+=normal[1]
		normal_points[ind_p1][2]+=normal[2]

		normal_points[ind_p2][0]+=normal[0]
		normal_points[ind_p2][1]+=normal[1]
		normal_points[ind_p2][2]+=normal[2]

		normal_points[ind_p3][0]+=normal[0]
		normal_points[ind_p3][1]+=normal[1]
		normal_points[ind_p3][2]+=normal[2]
                
def get_list(line,int_flag=0):
	line=string.split(line,'#')[0] # strip off comments
	elems_raw=string.split(line,' ') # get all elemets
	#print elems_raw
	# clean elemets from double whitespaces
	tup=[]
	for elem in elems_raw:
		n=0
		if len(elem)>0:
		#print ' ',elem
			ws=(elem[n] in string.whitespace)
			while ws&(n<len(elem)):
				ws=(elem[n] in string.whitespace)
				n+=1
			#print n,len(elem)-1
			if n<len(elem): # if not all whitespace
				if int_flag:
					tup+=[int(string.atof(elem)),]
				else:
					tup+=[string.atof(elem),]
	return tup
