from classlib.track import *

class Diverge_flexible(Track):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        self.info= 'Diverge track element with flexible sections.\n'+\
                   'Drag nodes to stretch and bend input and output sections.'
                   
        entryline={'shape': ( 'flexline', {'offset':(0.0,0.0,0.0),
                                           'endcoords':(30.0,0.0,0.0)} ),
                   'topo' : (1,2),
                   }
        
        straightbranch={'shape':( 'flexline', {'offset':(30.0,0.0,0.0),
                                               'endcoords':(80.0,0,0)}),
                        'topo' : (2,3),
                        }

        tobranch={'shape': ( 'flexline', {'offset':(30.0,0.0,0.0),
                                          'endcoords':(80.0,20.0,0.0),
                                          'alpha1':0.0}),
                  'topo' : (2,4)
                  }
        
        self.element=[entryline,straightbranch,tobranch]
        self.nodes_connect={1:'in', 3:'out',4:'out'}

        # define Type of track element when different from standard SISO
        self.Mod=Divmod # module specialized for 1:N diverge operations
        
