from classlib.track import *

class Merge_flexible(Track):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        self.info= 'Merge track element with flexible sections.\n'+\
                   'Drag nodes to stretch and bend input and output '+\
                   'sections.\n'+\
                   'Attention! The input lines must leave the carriers  '+\
                   'enough space to adapt their speed to those on the  '+\
                   'competing input line. Their length "l" must satisfy\n'+\
                   ' l > 0.5 * a * v^2 where "a" is maximum comfort'+\
                   ' decelleration and "v" the maximum line speed.'
        
        straightbrach={'shape':( 'flexline', {'offset':(0.0,0.0,0.0),
                                              'endcoords':(50.0,0.0,0.0)}),
                       'topo' : (1,2),
                       }

        frombranch={'shape': ( 'flexline', {'offset':(0.0,-20.0,0.0),
                                         'endcoords':(50.0,0.0,0.0),
                                         }),
                    'topo' : (3,2)
                    }
        outline={'shape': ( 'flexline', {'offset':(50.0,0.0,0.0),
                                         'endcoords':(80.0,0.0,0.0)} ),
                   'topo' : (2,4),
                   }
        
        self.element=[straightbrach,frombranch,outline]
        self.nodes_connect={1:'in', 3:'in',4:'out'}
        self.Mod=Mergemod
