from classlib.track import *

class Stop20_left_v16(Stop):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        
        
        self.element=[\
            # s0 entry
            {'label':'entry',
             'shape': ( 'line', {'offset':(0.0,0.0,0.0),
                                 'length':10.0} ),
             'velocity_line': 0.75*60.0/3.6,
             'topo' : (1,2),
             },
            # s1 main at entry
            {'label':'main_entry',
             'shape': ('line', {'offset':(10.0,0.0,0.0),
                                'length':110.0}),
             'velocity_line': 60.0/3.6,
             'clearingzone':40.0,
             'topo' : (2,3),
             },
            # s4 main at exit
            {'label':'main_exit',
             'shape': ('line', {'offset':(120.0,0.0,0.0),
                                'length':210.0}),
             'velocity_line': 60.0/3.6,
             'topo' : (3,4),
             },
            # s4 exit
            {'label':'exit',
             'shape': ('line', {'offset':(330.0,0.0,0.0),
                                'length':10.0}),
             'velocity_line': 60.0/3.6,
             'topo' : (4,5),
             },
            # s5 brake-line
            {'label':'brake',
             'velocity_line': 3.0,
             'shape': ('scurve', {'offset':(10.0,0.0,0.0),
                                  'length':110.0,
                                  'displace':5.0,
                                  'turn'  :'left'
                                  }),
             'clearingzone':40.0,
             'topo' : (2,6)
             },
            # s6 berths
            {'label':'berths',
             'type':'berth',
             'berth_no':    20,
             'berth_length':3.8,
             'berths_keep_clear': 10,
             'shape':         ('line', {'offset':(120.0,-5.0,0),
                                        'length':100.0}),
             'velocity_line': 3.0,
             'topo' :         (6,7),
             },
            #s7 acceleration-line
            {'label':'accel',
             'shape': ('scurve', {'offset':(220.0,-5.0,0.0),
                                  'length':110.0,
                                  'displace':5.0,
                                  'turn'  :'right'
                                  }),
             'velocity_line': 60.0/3.6,
             'topo' : (7,4)
             },
            ]

        self.nodes_connect={1:'in', 5:'out'}

        self.info= 'Stop with 20 berths which are off-line, '+\
                   'on the left side.\n'+\
                   'Default main line velocity is 16.6m/s\n '+\
                   'DO NOT EXCEED THIS VELOCITY !'+\
                   'Both nodes can be dragged in order to change the length.'
        # define class for this track element module
        self.Mod=Stopmod

    


